/*
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2008, 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function(){
dojo.provide("com.ibm.rdm.web.commenting.ResourceViewerWidget");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dojo.i18n");

dojo.require("com.ibm.rdm.web.commenting.EventTopics");
dojo.require("com.ibm.rdm.web.common.ErrorHandler");
dojo.require("com.ibm.rdm.web.common.MimeTypes");
dojo.require("com.ibm.rdm.web.common.ResourceLinksHandler");
dojo.require("com.ibm.rdm.web.common.UriHelper");
dojo.require("com.ibm.rdm.web.common.richtext.RichTextConverter");
dojo.require("com.ibm.rdm.web.history.revisionsHelper");
dojo.require("com.ibm.rdm.web.review.ReviewCache");
dojo.require("com.ibm.rdm.web.util.autoscroller");
dojo.require("com.ibm.rdm.web.util.domutils");
dojo.require("com.ibm.rdm.web.util.queryutils");
dojo.require("com.ibm.rdm.web.viewer.ScreenFlowUIActivityLoader");
dojo.require("com.ibm.rdm.web.viewer.embeddedResourceFactory");
dojo.require("com.ibm.rdm.web.viewer.viewerutils");
dojo.require("com.ibm.rdm.web.server.client.RDMClient");
dojo.require("com.ibm.rdm.web.server.XhrUtils");
dojo.require("com.ibm.rdm.web.common.controlTypes");

dojo.requireLocalization("com.ibm.rdm.web.commenting", "resourceviewer");
dojo.requireLocalization("com.ibm.rdm.web.common", "common");
dojo.requireLocalization("com.ibm.rdm.web.review", "reviewAndApprovalCommon");
dojo.requireLocalization("com.ibm.rdm.web.common", "ErrorSectionWidget");



var EventTopics = com.ibm.rdm.web.commenting.EventTopics;
var ResourceLinksHandler = com.ibm.rdm.web.common.ResourceLinksHandler;
var ReviewCache = com.ibm.rdm.web.review.ReviewCache;
var RichTextConverter = com.ibm.rdm.web.common.richtext.RichTextConverter;
var UriHelper = com.ibm.rdm.web.common.UriHelper;
var controlTypes = com.ibm.rdm.web.common.controlTypes;
var domutils = com.ibm.rdm.web.util.domutils;
var queryutils = com.ibm.rdm.web.util.queryutils;
var revisionsHelper = com.ibm.rdm.web.history.revisionsHelper;
var viewerutils = com.ibm.rdm.web.viewer.viewerutils;
var RDMClient = com.ibm.rdm.web.server.client.RDMClient;
var XhrUtils = com.ibm.rdm.web.server.XhrUtils;
var ErrorHandler = com.ibm.rdm.web.common.ErrorHandler;

dojo.declare(
	"com.ibm.rdm.web.commenting.ResourceViewerWidget",
	[dijit._Widget, dijit._Templated, com.ibm.rdm.web.viewer.ScreenFlowUIActivityLoader],
{
	templateString: "<div class=\"rdm-resource-viewer-widget\" dojoAttachPoint=\"_rootNode\"><div dojoType=\"dijit.layout.ContentPane\" dojoAttachPoint=\"_contentPane\" style=\"position: relative;padding: 15px 10px 10px 10px;\"></div></div>",
	widgetsInTemplate: true,
	resourceURI: null,
	resourceViewer: null,
	idNodesMap: {},

	_selectedNode: null,
	_locationsMarkedForComments: null,
	_documentHasBeenLoaded: false,
	_widthToUse: null,
	_heightToUse: null,
	_firstRenderingRequestForIEHasOccurred: null,
	_subscriptions: null,
	_isTextualContent: null,
	_messages: null,
	_commonMessages: null,
	_reviewMessages: null,
	_errorSectionWidgetMessages: null,
	_commentBubbles: {},
	_revision: null,
	// _connectionElementDivs: Array of DomNodes
	//    This array is only made use of if the artifact under display is a
	//    User Interface Sketch, Use-Case Diagram or Business Process Diagram.
	//    This array is populated with the div elements that specify their
	//    className as "connectionElement" (rather than "diagramElement").
	//    These "connectionElement" divs contain information about a connection
	//    in the underlying model and convey the start-point, end-point and,
	//    when appropriate, the intermediate kinks as well.
	_connectionElementDivs: null,
	// _processDiagramNodeElementDivs: Array of DomNodes
	//    This array is only made use of if the artifact under display is a
	//    BusinessProcessDiagram.  We need to separately track these "node"
	//    elements due to the fact that connection selection code _may_ need
	//    account for a node element (e.g. a "StartEvent") that lives below
	//    the rectangular area that represents the "hit rectangle" for a
	//    connection (including its kinks).
	_processDiagramNodeElementDivs: null,
	// _laneElementDivs: Array of DomNodes
	//    This array is only made use of if the artifact under display is a
	//    BusinessProcessDiagram.  We need to separately track these Lane
	//    elements due to the fact that connection selection code _may_ need
	//    account for a Lane element that lives below the rectangular area that
	//    represents the "hit rectangle" for a connection (including its
	//    kinks).
	_laneElementDivs: null,
	// _poolElementDivs: Array of DomNodes
	//    This array is only made use of if the artifact under display is a
	//    BusinessProcessDiagram.  We need to separately track these Pool
	//    elements due to the fact that connection selection code _may_ need
	//    account for a Pool element that lives below the rectangular area that
	//    represents the "hit rectangle" for a connection (including its
	//    kinks).
	_poolElementDivs: null,
	// _connectHandles: Array
	//    When the document is "refreshed" (by calling loadResource >1 time),
	//    we need to disconnect the last connected handles, but we don't want
	//    to override _Widget's _connect attribute ... so instead we make use
	//    of our own local '_connectHandles'.
	_connectHandles: null,

	postCreate: function() {
		this._documentHasBeenLoaded = false;
		this._locationsMarkedForComments = new Array();
		this._connectHandles = new Array();
		
		this._initSubscriptions();        
	},
	
   	postMixInProperties: function() {
		this._messages = dojo.i18n.getLocalization(
				"com.ibm.rdm.web.commenting", "resourceviewer");
		this._commonMessages = dojo.i18n.getLocalization(
				"com.ibm.rdm.web.common", "common");
		this._reviewMessages = dojo.i18n.getLocalization(
				"com.ibm.rdm.web.review", "reviewAndApprovalCommon");
		this._errorSectionWidgetMessages = dojo.i18n.getLocalization(
				"com.ibm.rdm.web.common", "ErrorSectionWidget");
   	},

	destroy: function() {
		for (var i = 0; i < this._subscriptions.length; i++) {
			dojo.unsubscribe(this._subscriptions[i]);
			this._subscriptions[i] = null;
		}
		this._subscriptions = [];
		this._documentHasBeenLoaded = false;
		this.inherited("destroy", arguments);
	},

	subscribe: function(topic, method) {
		var topic = EventTopics.getTopic(topic, this.resourceURI);
		ErrorHandler.debug("ResourceViewerWidget: subscribe to event -> " + topic);
		this._subscriptions.push(
				dojo.subscribe(
						topic, 
						this, 
						method));
	},

	publish: function(topic, params) {
		var topic = EventTopics.getTopic(topic, this.resourceURI);
		ErrorHandler.debug("ResourceViewerWidget: fire event -> " + topic);
		dojo.publish(
				topic, 
				params);
	},

	_initSubscriptions: function() {
		this._subscriptions = [];
		this.subscribe(EventTopics.RESOURCE_LOCATION_PANE_SELECTED_TOPIC, "_onLocationPaneSelected");
		this.subscribe(EventTopics.LOCATE_COMMENTED_LOCATIONS_IN_RESOURCE, "_onHighlightComments");
		this.subscribe(EventTopics.RESOURCE_LOCATION_PANE_HOVER_TOPIC, "_onLocationPaneHover");
	},

	highlightComments: function(locationCommentDetails) {
	},

	select: function(node) {
		if (this.isSelected(node))
			return;
		var embeddedType = node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE);
		if (embeddedType) {	
			if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_RICHTEXT) {
				dojo.addClass(node, "embeddedRTSelected");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_REQUIREMENT) {
				dojo.addClass(node, "embeddedRTSelected");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_USECASE) {
				dojo.addClass(node, "embeddedRTSelected");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_ACTOR) {
				dojo.addClass(node, "embeddedRTSelected");
			}
			else {
				dojo.addClass(node, this._getNodeSelectedCssClass());
			}
		}
		else if (this._isConnectionElement(node)) {
			this._selectConnection(node);
		}
		else {
			dojo.addClass(node, this._getNodeSelectedCssClass());
		}
		this.unselect(this._selectedNode);
		this._selectedNode = node;        
	},

	unselect: function(node) {
		if (!this.isSelected(node))
			return;
		var embeddedType = node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE);
		if (embeddedType) {    		
			if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_RICHTEXT) {
				dojo.removeClass(node, "embeddedRTSelected");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_REQUIREMENT) {
				dojo.removeClass(node, "embeddedRTSelected");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_USECASE) {
				dojo.removeClass(node, "embeddedRTSelected");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_ACTOR) {
				dojo.removeClass(node, "embeddedRTSelected");
			}
			else {
				dojo.removeClass(node, this._getNodeSelectedCssClass());
			}
		}
		else if (this._isConnectionElement(node)) {
			this._unselectConnection(node);
		}
		else {
			dojo.removeClass(node, this._getNodeSelectedCssClass());
		}
		
		this._selectedNode = null;
	},

	toggleSelection: function(node) {
		if (this.isSelected(node)) {
			this.unselect(node);
		}
		else {
			this.select(node);
		}
	},

	isSelected: function(node /*Node */) {
		return node && this._selectedNode && this._selectedNode == node;
	},

	_getNodeSelectedCssClass: function() {
		return (this._isTextualContent ? "richTextNodeSelected" : "diagramNodeSelected");
	},

	hoverOver: function(node /*Node*/) {        
		var embeddedType = node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE);
		if (embeddedType) {
			if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_RICHTEXT) {
				dojo.addClass(node, "embeddedRTCommentHover");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_REQUIREMENT) {
				dojo.addClass(node, "embeddedRTCommentHover");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_USECASE) {
				dojo.addClass(node, "embeddedRTCommentHover");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_ACTOR) {
				dojo.addClass(node, "embeddedRTCommentHover");
			}
			else {
				dojo.addClass(node, "commentHover");
			}
		}
		else {
			dojo.addClass(node, "commentHover");
		}
	},

	hoverOut: function(node /*Node*/) {
		var embeddedType = node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE);
		if (embeddedType) {
			if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_RICHTEXT) {
				dojo.removeClass(node, "embeddedRTCommentHover");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_REQUIREMENT) {
				dojo.removeClass(node, "embeddedRTCommentHover");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_USECASE) {
				dojo.removeClass(node, "embeddedRTCommentHover");
			}
			else if (embeddedType == XML_ELEMENT_ATTRIBUTE_RDMTYPE_ACTOR) {
				dojo.removeClass(node, "embeddedRTCommentHover");
			}
			else {
				dojo.removeClass(node, "commentHover");
			}
		}
		else {
			dojo.removeClass(node, "commentHover");
		}
	},
	setDimensions: function(width, height) {
		this._setDimensions(width, height);
	},

	_setDimensions: function(width, height) {
		// Note: width and height are optional.
		if (width && height) {
			this._widthToUse = width;
			this._heightToUse = height;
		}
		if( this._documentHasBeenLoaded && this._widthToUse && this._heightToUse) {
			var widthToUse = this._widthToUse;
			this.domNode.style.height = this._heightToUse + "px";
			this.domNode.style.width = this._widthToUse + "px";
			var contentPaneSize = {
					h: this._heightToUse,
					w: this._widthToUse
			};
			this._contentPane.resize(contentPaneSize);
		}
		this._positionCommentBubbles();
	},

	_isConnectionElement: function(node) {
		return (node.className === "connectionElement");
	},

	_selectConnection: function(node) {
		var connectionPoints = eval(node.getAttribute("connectionPoints"));
		var nodeLeft = parseInt(node.style.left, 10);
		var nodeTop = parseInt(node.style.top, 10);
		var kinkCenterOffsetX = Math.round(CONNECTION_KINK_WIDTH/2);
		var kinkCenterOffsetY = Math.round(CONNECTION_KINK_HEIGHT/2);
		var createKink = function(centerX, centerY) {
			var div = document.createElement("div");
			div.className = "connectionKink";
			div.style.left = (centerX - kinkCenterOffsetX) + "px";
			div.style.top = (centerY - kinkCenterOffsetY) + "px";
			return div;
		};
		var createMidpointKink = function(x1, y1, x2, y2) {
			var x = Math.round((x1 + x2)/2);
			var y = Math.round((y1 + y2)/2);
			return createKink(x, y);
		}
		var lastKinkCenterX = null;
		var lastKinkCenterY = null;
		for (var i = 0; i < connectionPoints.length; i++) {
			var centerX = connectionPoints[i].x - nodeLeft;
			var centerY = connectionPoints[i].y - nodeTop;
			if (i > 0) {
				node.appendChild(createMidpointKink(centerX, centerY, lastKinkCenterX, lastKinkCenterY));
			}
			node.appendChild(createKink(centerX, centerY));
			lastKinkCenterX = centerX;
			lastKinkCenterY = centerY;
		}
	},

	_unselectConnection: function(node) {
		domutils.removeChildNodes(node);
	},

	_pointToSegmentDistance: function(c, a, b) {
		// summary:
		//    Given a point C and a line segment defined by points A and B,
		//    return the distance that C is from this line segment.
		var dotProduct = function(a, b, c) {
			// Return the dotProduct product of (AB, BC)
			var ABx = b.x - a.x;
			var ABy = b.y - a.y;
			var BCx = c.x - b.x;
			var BCy = c.y - b.y;
			return ABx * BCx + ABy * BCy;
		};
		var crossProduct = function(a, b, c) {
			// Return the cross product AB x AC
			var ABx = b.x - a.x;
			var ABy = b.y - a.y;
			var ACx = c.x - a.x;
			var ACy = c.y - a.y;
			return ABx * ACy - ABy * ACx;
		};
		var distance = function(a, b) {
			// Return the distance from A to B
			var dist1 = a.x - b.x;
			var dist2 = a.y - b.y;
			return Math.sqrt(dist1*dist1 + dist2*dist2);
		};
		var dot = dotProduct(a, b, c);
		if (dot > 0) {
			return distance(b, c);
		}
		dot = dotProduct(b, a, c);
		if (dot > 0) {
			return distance(a, c);
		}
		return Math.abs(crossProduct(a, b, c) / distance(a, b));
	},

	_getDiagramLocationForClickEvent: function(event) {
		var coords = dojo.coords(this._contentPane.domNode);
		var x = event.pageX - coords.x + this._contentPane.containerNode.scrollLeft;
		var y = event.pageY - coords.y + this._contentPane.containerNode.scrollTop;
		return { x: x, y: y };
	},

	_isPointInDiv: function(x, y, div, /*Integer?*/divParentOffsetX, /*Integer?*/divParentOffsetY) {
		var divX = parseInt(div.style.left, 10);
		var divY = parseInt(div.style.top, 10);
		var divOffset = {
			x: (divParentOffsetX || 0),
			y: (divParentOffsetY || 0)
		};
		if (x > (divX + divOffset.x) && y > (divY + divOffset.y)) {
			var divWidth = parseInt(div.style.width, 10);
			var divHeight = parseInt(div.style.height, 10);
			if (x < (divX + divWidth + divOffset.x)
				&& y < (divY + divHeight + divOffset.y)
				) {
				return true;
			}
		}
		return false;
	},

	_getClickedConnectionDiv: function(clickedDiv, diagramClickPoint) {
		// summary:
		//    Hittest for finding a connetion that the user may have clicked on.
		// description:
		//    The user has clicked within the rectangle region encompassing a
		//    particular connection.  However, the user MAY NOT have clicked
		//    close enough to the connection for us to consider it a "hit" (for
		//    example consider a diagonal connection and the user clicking close
		//    to one of the two corners furthest from this connection).  In
		//    addition, it MAY be the case that there's another connection
		//    involving a line segment that is even closer to the clicked
		//    position than the div that received the "onclick" event.  For
		//    example consider the case of two incoming links to the left side
		//    of a UIActivity in a Screen Flow; the divs representing these two
		//    connections would overlap each other, but only one of them would
		//    receive the "onclick" event.  This function's job is to quickly
		//    find the divs whose encompassing rectangles "live below" the
		//    clicked position and amongst these divs, find the single div which
		//    contains a line segment that is closest to the clicked position
		//    (but whose distance away cannot exceed the value found in
		//    CONNECTION_HIT_TEST_PIXEL_DELTA_THRESHOLD).
		// return: a "connectionElement" div or null
		//
		var x = diagramClickPoint.x;
		var y = diagramClickPoint.y;
		// Note: we initialize closestConnDistance to a value that exceeds the
		// CONNECTION_HIT_TEST_PIXEL_DELTA_THRESHOLD.  The "for" loops that
		// follow this _may_ find a connection in which the distance to one of
		// its segments is below this threshold.  Only if this is the case will
		// this function end up returning a non-null value ...
		var closestConnDistance = CONNECTION_HIT_TEST_PIXEL_DELTA_THRESHOLD + 1;
		var closestConnDiv = null;
		for (var i = 0; i < this._connectionElementDivs.length; i++) {
			var connDiv = this._connectionElementDivs[i];
 			if (clickedDiv === connDiv || this._isPointInDiv(x, y, connDiv)) {
				var connectionPoints = eval(connDiv.getAttribute("connectionPoints"));
				for (var j = 0; j < connectionPoints.length; j++) {
					if (j < (connectionPoints.length - 1)) {
						var distance =
							this._pointToSegmentDistance(
								diagramClickPoint,
								connectionPoints[j],
								connectionPoints[j+1]
							);
						if (distance < closestConnDistance) {
							closestConnDistance = distance;
							closestConnDiv = connDiv;
						}
					}
				}
			}
		}
		return (
			(closestConnDistance <= CONNECTION_HIT_TEST_PIXEL_DELTA_THRESHOLD) ?
			closestConnDiv :
			null
		);
	},

	_onConnectionClicked: function(event) {
		// summary:
		//    If appropriate, toggle selection and publish a selection event.
		// description:
		//    A click has just occurred on the "hot region" that represents
		//    a connection (i.e. a div of controlType "connectionElement").
		//    Checking must be done to see which connection div should actually
		//    be the target for the click (please see the function documentation
		//    for _getClickedConnectionDiv to see why).  Or, if it's determined
		//    that the click wasn't close enough to target any of the diagram's
		//    connections, we must then consider the special case of a Business
		//    Process Diagram -- as the click may need to be directed to the
		//    underlying "node" (e.g. a "StartEvent") Lane or Pool that lives
		//    below the clicked div.  If this special case IS encountered, we
		//    simply forward the request off to _onElementClicked instead.
		// event:
		//    A DOM click event.
		dojo.stopEvent(event);
		var diagramClickPoint = this._getDiagramLocationForClickEvent(event);
		var node = this._getClickedConnectionDiv(
			event.currentTarget, diagramClickPoint);
		if (node) {
			// A connection was clicked on.
			var unselectedNodeId = null;
			var selectedNodeId = null;
			if (this._selectedNode) {
				unselectedNodeId = this._selectedNode.id;
			}
			this.toggleSelection(node);
			if (this._selectedNode) {
				selectedNodeId = this._selectedNode.id;
			}
			this.publish(EventTopics.COMMENT_SELECTED_TOPIC, [selectedNodeId, unselectedNodeId]);
		}
		else {
			// Although the connection's "hot region" was clicked, the the click
			// occurred far enough away that we can't consider it a "hit".
			
			// It _may_ be the case that there's a "node" (e.g. a "StartEvent")
			// Lane or Pool underneath the "hit region" representing the clicked
			// connection.  In this case we want to process things as though the
			// original click took place on that "diagramElement" div (instead
			// of the overlaying "connectionElement" div that received the click
			// event).
			var self = this;
			var getUnderlyingProcessDiagramNodeDiv = function(x, y) {
				// Note: We're using an OR here to give preference to a node
				// found within a "Group Annotation" rather than the containing
				// "Group Annotation" (in cases where this might occur).
				return (
					self._getUnderlyingProcessDiagramNodeDiv(x, y, true)
					|| self._getUnderlyingProcessDiagramNodeDiv(x, y, false)
				);
			};
			var getUnderlyingLaneOrPoolDiv = function(x, y) {
				if (self._laneElementDivs) {
					for (var i = 0; i < self._laneElementDivs.length; i++) {
						var div = self._laneElementDivs[i];
						var poolX = parseInt(div.parentNode.style.left, 10);
						var poolY = parseInt(div.parentNode.style.top, 10);
						if (self._isPointInDiv(x, y, div, poolX, poolY)) {
							return div;
						}
					}
				}
				if (self._poolElementDivs) {
					for (var i = 0; i < self._poolElementDivs.length; i++) {
						var div = self._poolElementDivs[i];
						if (self._isPointInDiv(x, y, div)) {
							return div;
						}
					}
				}
				return null;
			};
			var underlyingElementDiv = (
				getUnderlyingProcessDiagramNodeDiv(diagramClickPoint.x, diagramClickPoint.y)
				|| getUnderlyingLaneOrPoolDiv(diagramClickPoint.x, diagramClickPoint.y)
			);
			if (underlyingElementDiv) {
				this._onElementClicked(event, underlyingElementDiv);
			}
		}
	},

	_getUnderlyingProcessDiagramNodeDiv: function(x, y, /*Boolean?*/doExcludeAnnotationNodes) {
		// summary:
		//    If the current artifact is a Business Process Diagram, return the
		//    first "node" div found whose "hot region" includes the passed x/y
		//    location.  If 'doExcludeAnnotationNodes' is passed, we exclude from
		//    consideration all nodes that represent "Group Annotation" nodes in
		//    the rich client.
		if (this._processDiagramNodeElementDivs) {
			var self = this;
			var getParentNodeOffset = function(node) {
				var offset = { x: 0, y: 0 };
				var parentNode = node.parentNode;
				while (parentNode !== self._contentPane.domNode) {
					var nodeOffsetX =
						(parentNode.style.left ? parseInt(parentNode.style.left, 10) : 0);
					var nodeOffsetY =
						(parentNode.style.top ? parseInt(parentNode.style.top, 10) : 0);
					offset.x += nodeOffsetX;
					offset.y += nodeOffsetY;
					parentNode = parentNode.parentNode;
				}
				return offset;
			};
			for (var i = 0; i < this._processDiagramNodeElementDivs.length; i++) {
				var div = this._processDiagramNodeElementDivs[i];
				var parentDivOffset = getParentNodeOffset(div);
				var doExclude = (doExcludeAnnotationNodes && this._isProcessDiagramAnnotationNode(div));
				if (!doExclude && this._isPointInDiv(x, y, div, parentDivOffset.x, parentDivOffset.y)) {
					return div;
				}
			}
		}
		return null;
	},

	_isProcessDiagramAnnotationNode: function(node) {
		// summary:
		//    Returns true iff node represents a "Group Annotation" node in
		//    a Business Process Diagram.  By "Group Annotation" node, we mean
		//    a node that was originally created via dragging out a "Group
		//    Annotation" node from the rich client's editor pallet.
		return (
			this._processDiagramNodeElementDivs // This will only be true if we're in a Business Process Diagram
			&& node.id
			&& (node.id.substring(0, 17) // Note: 17 is the length of "AnnotationElement"
				=== "AnnotationElement")
		);
	},

	_onElementClicked: function(event, /*Optional*/targetElement) {
		// summary:
		//    Toggle selection and publish a selection event.
		// event:
		//    A DOM click event.
		// targetElement:
		//    If passed, this element will be used for selection rather than
		//    the element found in event.currentTarget.
		dojo.stopEvent(event);
		var node = (targetElement || event.currentTarget);
		// TODO Change the converter code to make sure that "Group Annotation"
		// nodes are added BEFORE all other node types within the HTML document
		// that it produces.  If the document were structured this way, the
		// nodes "inside" the Group Annotations would occlude the Group
		// Annotations and be "hit" before them ... which would mean we could
		// avoid the need for following 'if' clause ...
		if (event && this._isProcessDiagramAnnotationNode(node)) {
			// Note: If the selected element represents a "Group Annotation"
			// element we need to account for the fact that the user may have
			// intended to click on a node found within this annotation rather
			// than the annotation itself.
			var diagramClickPoint = this._getDiagramLocationForClickEvent(event);
			var underlyingNode = this._getUnderlyingProcessDiagramNodeDiv(
				diagramClickPoint.x, diagramClickPoint.y, true);
			if (underlyingNode) {
				node = underlyingNode;
			}
		}
		var unselectedNodeId = null;
		var selectedNodeId = null;
		if (this._selectedNode) {
			unselectedNodeId = this._selectedNode.id;
		}
		this.toggleSelection(node);
		if (this._selectedNode) {
			selectedNodeId = this._selectedNode.id;
		}
		this.publish(EventTopics.COMMENT_SELECTED_TOPIC, [selectedNodeId, unselectedNodeId]);
	},

	_getRootArtifactNode: function() {
		var r = this._contentPane.domNode;
		return r;
		/*
		var iframe = this._iframeNode;
		if(dojo.isIE){
			return iframe.contentWindow.document.body;
		}else if(dojo.isSafari){
			return iframe.document.documentElement;
		}else{ 
			return iframe.contentDocument.documentElement;
		}
		*/
	},

	loadResource: function(contentType, revision,
						   /*Integer?*/storyboardFrameIndex) {
		this._revision = revision;
		this.idNodesMap = {};
		this._connectionElementDivs = [];
		this._documentHasBeenLoaded = false;
		var normalizedContentType =
			queryutils.getNormalizedContentType(contentType);
		var isImageConversionContentType =
			com.ibm.rdm.web.common.MimeTypeRegistry.isImageConversionContentType(contentType);
		var self = this;
		var reviewParser = null;
		
		var onGetSuccess = function(response) {
			self._clearLastResultsIfNeeded();
			// var idoc = self._iframeDoc();
			if (normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RICH_TEXT
				|| normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQUIREMENT
				|| normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SKETCH
				|| normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PART
				|| normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SCREEN_FLOW
				|| normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_STORY_BOARD
				|| normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PROCESS
				|| normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE_DIAGRAM
				|| normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ACTOR
				|| normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE) {
				// The resource represents a content type that we know how to handle.
				switch (normalizedContentType) {
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RICH_TEXT:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQUIREMENT:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ACTOR:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE:
						self._isTextualContent = true;
						
						var htmlDoc = RichTextConverter.convertRrcXhtmlToHtml(response.doc);
						self._contentPane.attr('content', htmlDoc);
											
    					if (normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RICH_TEXT){
    						var tables = dojo.query("table", self._getRootArtifactNode());
    						for (var i=0; i < tables.length; i++) {
    							var columns = dojo.query("col", tables[i]);
    							for (var g=0; g < columns.length; g++){
    								if (columns[g].width.indexOf("%") != -1){
    									tables[i].setAttribute("width", "95%");
    									break;
    								}
    							}
    						}   						
    					}
						
						// var links = dojo.query("a", idoc);
						// IE transforms the anchors differently. All links to internal resources becomes
						// for e.x. 'https://hostname:port/composer/web/rrc28'
						// FF leaves it as 'rrc28'
						var links = dojo.query("a", self._getRootArtifactNode());
						var idnodes = dojo.query("[id]", self._getRootArtifactNode());
							
						for (var i=0; i<idnodes.length; i++) {
							// add the event handler to the node
							self._connectHandles.push(
								self.connect(idnodes[i], "onclick", self._onElementClicked));
							self.idNodesMap[idnodes[i].id] = idnodes[i];
						}
							
						for (var i = 0; i < links.length; i++) {
							var linkHref = links[i].attributes.getNamedItem("xmlsrc").value;
							if (ResourceLinksHandler.isLinkInternal(linkHref)) {
								//internal resource
								var href = queryutils.getFullyQualifiedUriFromAbsoluteResourceAndRelativeResource(this.resourceURI, linkHref);
								links[i].setAttribute("href", href);
							}
							self._connectHandles.push(
								self.connect(links[i], "onclick", self._handleAnchorClicked)); 
						}        						
						self._loadEmbeddedResources(self._getRootArtifactNode(), 0, reviewParser);
						break;
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SKETCH:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PART:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SCREEN_FLOW:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_STORY_BOARD:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PROCESS:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE_DIAGRAM:
						self._isTextualContent = false;
						// TODO Accommodate the same padding that rich text uses
						self._contentPane.domNode.style.paddingTop = "0px";
						self._contentPane.domNode.style.paddingRight = "0px";
						self._contentPane.domNode.style.paddingBottom = "0px";
						self._contentPane.domNode.style.paddingLeft = "0px";
						var content = "";                        
						content = viewerutils.transformImageGenerationDocument(response.ioArgs.xhr.responseText);
						self._contentPane.domNode.style.position = "absolute";
						self._contentPane.attr('content', content);
						var idNodes = dojo.query("[id]", self._getRootArtifactNode());
						var isBusinessProcessSketch =
							(com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PROCESS === normalizedContentType);
						if (isBusinessProcessSketch) {
							self._poolElementDivs = [];
							self._laneElementDivs = [];
							self._processDiagramNodeElementDivs = [];
						}
						// Register a click handler for all selectable div elements and set up
						// the alt attribute as well ...
						for (var i = 0; i < idNodes.length; i++) {
							var node = idNodes[i];
							self._setAltAttributeForRenderedArtifactDivElement(node);
							if (self._isConnectionElement(node)) {
								// Add a connection click handler.
								self._connectHandles.push(
									self.connect(node, "onmousedown", self._onConnectionClicked));
								self._connectionElementDivs.push(node);
							} else {
								// Add a node click handler.
								if (isBusinessProcessSketch) {
									// To appropriately handle the case of clicks in connection
									// "hot regions" that should be passed down to an underlying
									// node, we need to keep track of the "node types" that
									// the a connection click might be needed to surface as the
									// real click target.
									if (node.getAttribute("controlType") === "Pool") {
										self._poolElementDivs.push(node);
									} else if (node.getAttribute("controlType") === "Lane") {
										self._laneElementDivs.push(node);
									} else {
										self._processDiagramNodeElementDivs.push(node);
									}
								}
								self._connectHandles.push(
									self.connect(node, "onmousedown", self._onElementClicked));
							}
							self.idNodesMap[node.id] = node;
						}
						if (normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SCREEN_FLOW) {
							self._loadUIActivities(
								self._getRootArtifactNode(), reviewParser,
								self.resourceViewer.projectSnapshotURI);
						}
						if (normalizedContentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_STORY_BOARD) {
							this.publish(EventTopics.STORYBOARD_FRAME_LOADED_TOPIC, []);
						}
						break;
				}
				self._documentHasBeenLoaded = true;
				self._firstRenderingRequestForIEHasOccurred = false;
				self._setDimensions();
				//this.publish(EventTopics.RESOURCE_LOADED_IN_VIEWER_TOPIC, [self]);
			} else {
				// The resource represents a content type that we don't yet know
				// how to handle.
				self._showUnableToOpenContentTypeBody();
				self._documentHasBeenLoaded = true;
				self._firstRenderingRequestForIEHasOccurred = false;
				self._setDimensions();
			}
			return response; 
		};
		
		var deferred = RDMClient.doGet({
				uri: this.resourceURI,
				revision: revision,
				projectSnapshotURI: this.resourceViewer.projectSnapshotURI
			});
		if (normalizedContentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SKETCH || 
				normalizedContentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PART || 
				normalizedContentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SCREEN_FLOW || 
				normalizedContentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_STORY_BOARD || 
				normalizedContentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PROCESS || 
				normalizedContentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE_DIAGRAM
			) {
			var htmlgenDeferred = null;
			// If it's associated with a review, we must set reviewParser
			// appropriately (for example to enable us to compose review related
			// query params for GETs to converter for GEF-based embeds).
			if (this.resourceViewer.reviewId) {
				var onReviewLoaded = function(response) {
					reviewParser = response.doc;
					htmlgenDeferred = RDMClient.doGet({
						uri: self._getConversionURL(
								self.resourceURI, normalizedContentType, revision,
								storyboardFrameIndex, reviewParser),
						projectSnapshotURI: self.resourceViewer.projectSnapshotURI,
						skipErrors: true
					});
					htmlgenDeferred.addCallback(self, onGetSuccess);
					htmlgenDeferred.addErrback(self, self._showArtifactLoadError);
					return response;
				};
				var reviewDeferred = ReviewCache.getReview(this.resourceViewer.reviewId);
				reviewDeferred.addCallback(onReviewLoaded);
			} else {
				htmlgenDeferred = RDMClient.doGet({
					uri: this._getConversionURL(
						this.resourceURI, normalizedContentType, revision, storyboardFrameIndex
					),
					skipErrors: true
				});
				htmlgenDeferred.addCallback(this, onGetSuccess);
				htmlgenDeferred.addErrback(this, this._showArtifactLoadError);
			}
		}
		else {
			deferred.addCallback(this, onGetSuccess);
		}

		return deferred;
	},

	_showArtifactLoadError: function(response) {
		this._contentPane.attr('content', "");
		if (response.ioArgs.xhr.status == 403) {
			var msg = this._errorSectionWidgetMessages.Error_403;
			var urls = dojo.trim(response.ioArgs.xhr.responseText).split(" ");
			var unorderedListString = "<ul>";
			for (var i = 0; i < urls.length; i++) {
				unorderedListString += "<li>" + urls[i] + "</li>";
			}
			unorderedListString += "</ul>";
			var details = dojo.string.substitute(
				this._reviewMessages.canNotViewDependentArtifacts,
				[unorderedListString]);
			com.ibm.rdm.web.common.ErrorHandler.getErrorSectionWidget().showErrorMessage(
				msg, details);
		} else {
			com.ibm.rdm.web.common.ErrorHandler.getErrorSectionWidget().showXhrError(
				response, response.ioArgs);
		}
		return response;
	},

	setHtmlContent: function(htmlContent) {
		// summary:
		//    Reset the displayed HTML content to be the passed htmlContent.
		//    This method is normally called during initial opening or
		//    subsequent refreshing of the artifact under view.
		this._contentPane.attr('content', htmlContent);
	},

	_setAltAttributeForRenderedArtifactDivElement: function(div) {
		var controlId = div.getAttribute("id");
		var controlLabel = this.resourceViewer.getElementDisplayName(controlId);
		var controlType = div.getAttribute("controlType");
		var controlTypeDisplayName =
			controlTypes.getControlTypeDisplayName(controlType);
		var altText = null;
		if (controlLabel && controlLabel.length > 0) {
			altText = dojo.string.substitute(this._messages.fieldValue, [controlTypeDisplayName, controlLabel]);
		} else {
			altText = controlTypeDisplayName;
		}
		div.setAttribute("alt", altText);
	},

	_navigibleUIActivityIsLoading: function(div, resourceURI) {
		// summary:
		//    This is an override of a mixin function from ScreenFlowUIActivityLoader.
	},

	_contentForUIActivityHasBeenRendered: function(
		   uiActivityDiv, isRenderedAsArtifactImage, resourceURI) {
		// summary:
		//    This is an override of a mixin function from ScreenFlowUIActivityLoader.
		var self = this;
		if (isRenderedAsArtifactImage) {
			this._connectHandles.push(
				this.connect(
					uiActivityDiv,
					"ondblclick",
					function(event) {
						self._handleArtifactDoubleClicked(
							event, resourceURI);
					}
				)
			);
		}
	},

	_checkExternallyEmbedded: function(node, resourceURI /* String, src attribute */) {
		try {
			if (com.ibm.rdm.web.links.linkutils.isFromAnotherRepository(resourceURI)) {
				var msg = dojo.string.substitute(this._messages.embeddeddifferentrepo, [resourceURI]);
				var errorSpan = document.createElement("SPAN");
				var textNode = document.createTextNode(msg);
				errorSpan.appendChild(textNode);
				dojo.addClass(errorSpan, "error");
				if (node.tagName == "img" || node.tagName == "IMG") {
					dojo.place(errorSpan, node, "after");
					node.parentNode.removeChild(node);
				}
				else {
					node.innerHTML = "";
					node.appendChild(errorSpan);
				}
				return true;
			}
		}
		catch(e) {
			com.ibm.rdm.web.common.ErrorHandler.getErrorSectionWidget().showErrorNumber(
				7204, [resourceURI], e
			);
		}
		return false;
	},

	_loadEmbeddedResources: function(parentResource, embeddedLevel, /*Optional*/reviewParser) {
		var self = this;
		var images = dojo.query("img[xmlSrc]", parentResource);
		var richTextArtifacts =
			dojo.query(
				"[" + XML_ELEMENT_ATTRIBUTE_RDMTYPE + "='" + XML_ELEMENT_ATTRIBUTE_RDMTYPE_RICHTEXT + "']",
				parentResource);
		var diagrams =
			dojo.query("[" + XML_ELEMENT_ATTRIBUTE_RDMTYPE + "='" + XML_ELEMENT_ATTRIBUTE_RDMTYPE_DIAGRAM + "']",
				parentResource);
		var loadEmbeds = dojo.hitch(this, function(/*Object?*/reviewParser) {
			// Load embedded rich text artifacts.
			for (var i = 0; i < richTextArtifacts.length; i++) {
				var rtNode = richTextArtifacts[i];
				var uriAttribute = this._trimResourceSrcAttribute(rtNode.attributes.getNamedItem("xmlsrc").value);
				if (uriAttribute) {
					rtNode.innerHTML = this._commonMessages.loading;
					if (ResourceLinksHandler.isLinkInternal(uriAttribute)) {
						//internal resource
						uriAttribute = queryutils.getFullyQualifiedUriFromAbsoluteResourceAndRelativeResource(this.resourceURI, uriAttribute);
						rtNode.setAttribute("src", uriAttribute);
					}
					this._fetchEmbeddedResource(
						uriAttribute, rtNode,
						com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RICH_TEXT,
						embeddedLevel, reviewParser);
				}
			}
			// Load embedded GEF based artifacts.
			for (var i = 0; i < diagrams.length; i++) {
				var diagram = diagrams[i];
				var diagramSrc = diagram.attributes.getNamedItem("xmlsrc").value;
				if (ResourceLinksHandler.isLinkInternal(diagramSrc)) {
					//internal resource
					diagramSrc = queryutils.getFullyQualifiedUriFromAbsoluteResourceAndRelativeResource(this.resourceURI, diagramSrc);
					diagram.setAttribute("src", diagramSrc);
				}
				if (diagramSrc) {
					this._fetchEmbeddedResource(
						diagramSrc, diagram,
						com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_DIAGRAM,
						embeddedLevel, reviewParser);
				}
			}
			// Load images.
			for (var i = 0; i < images.length; i++) {
				var image = images[i];
				var imgSrcAttr = image.attributes.getNamedItem("xmlsrc");
				if (imgSrcAttr) {
					var imgSrc = imgSrcAttr.value;
					if (ResourceLinksHandler.isLinkInternal(imgSrc)) {
						//image may be transformed, so hide it until we finish processing
						dojo.addClass(image, "dijitDisplayNone");
						//internal resource
						imgSrc = queryutils.getFullyQualifiedUriFromAbsoluteResourceAndRelativeResource(this.resourceURI, imgSrc);
						image.setAttribute("imgSrc", imgSrc);
					
						this._fetchEmbeddedResource(
							imgSrc, image,
							com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_IMAGE,
							embeddedLevel, reviewParser);
						//if(!this._checkExternallyEmbedded(image, imgSrc) 
						//		&&  com.ibm.rdm.web.links.linkutils.sameLocation(imgSrc))
							this._connectHandles.push(
									this.connect(image, "ondblclick", this._handleArtifactDoubleClicked));
					}
				}
			}
			this._positionCommentBubbles();
		});
		if (reviewParser) {
			loadEmbeds(reviewParser);
		}
		else if (this.resourceViewer.reviewId) {
			var onReviewLoaded = function(response) {
				reviewParser = response.doc;
				loadEmbeds(reviewParser);
				return response;
			};
			var reviewDeferred = ReviewCache.getReview(this.resourceViewer.reviewId);
			reviewDeferred.addCallback(onReviewLoaded);
		} else {
			loadEmbeds();
		}
	},

	_fetchEmbeddedResource: function(resourceId, node, contentType, embeddedLevel, /*Optional*/reviewParser) {
		// summary:
		//    Load an embedded resource into the currently opened rich-text
		//    based artifact.
		// resourceId:
		//    A resource id such as "rrc141".  Note: For rich text types, this
		//    is instead passed as something like "rrc162#_IwBF8TM0Ed6VK9Tv6X1VcQ".
		if (this._checkExternallyEmbedded(node, resourceId)) {
			// The resource came from a different repo ... don't do anything
			// in this case.
			return;
		}
		var self = this;
		var resourceURI = this._trimResourceSrcAttribute(resourceId);
		var node = node;
		var onGetSuccess = function (response) {
			if (!(response instanceof Error)) {
				// success
				var realContentType = response.ioArgs.xhr.getResponseHeader("Content-Type");
				realContentType = queryutils.getNormalizedContentType(realContentType);
				switch (realContentType) {
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RICH_TEXT:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQUIREMENT:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ACTOR:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE:
						var src = node.getAttribute("src");
						var imageSpanNode = dojo.doc.createElement("span");
						imageSpanNode.style.background = "white";
						var imageNode = dojo.doc.createElement("img");
						
						imageSpanNode.style.position = "relative";
						imageSpanNode.style.left = "-10px";
						imageSpanNode.style.top = "-5px";
						imageSpanNode.appendChild(imageNode);
						// handles double click on the embedded artifact's header
						imageSpanNode.setAttribute("src", src);
						
						//12957: Comment bubble does not show on some paragraphs in IE
						if (embeddedLevel > 0) {
							node.style.position = "relative";
							node.style.left = "-5px";
						}
						
						switch (realContentType) {
							case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQUIREMENT:
								node.setAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE, XML_ELEMENT_ATTRIBUTE_RDMTYPE_REQUIREMENT);
								imageNode.setAttribute("src", "com.ibm.rdm.web/common/images/resources/requirement.gif");		            		
								dojo.addClass(node, "embeddedRequirement");
								break;
							case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RICH_TEXT:
								node.setAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE, XML_ELEMENT_ATTRIBUTE_RDMTYPE_RICHTEXT);
								imageNode.setAttribute("src", "com.ibm.rdm.web/common/images/resources/richtext.gif");		            		
								dojo.addClass(node, "embeddedRichtext");
								break;
							case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ACTOR:
								node.setAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE, XML_ELEMENT_ATTRIBUTE_RDMTYPE_ACTOR);
								imageNode.setAttribute("src", "com.ibm.rdm.web/common/images/resources/Actor.gif");		            		
								dojo.addClass(node, "embeddedActor");
								break;
							case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE:
								node.setAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE, XML_ELEMENT_ATTRIBUTE_RDMTYPE_USECASE);
								imageNode.setAttribute("src", "com.ibm.rdm.web/common/images/resources/uc_resource.gif");		            		
								dojo.addClass(node, "embeddedUsecase");
								break;
						}
						var baseName = queryutils.getArtifactNameFromArtifactContent(response.doc);
						var titleSpan = dojo.doc.createElement("span");
						dojo.addClass(titleSpan, "embeddedRTTitle");
						// handles double click on the embedded artifact's header
						titleSpan.setAttribute("src", src);
						titleSpan.appendChild(document.createTextNode(baseName));
						
						var htmlText = RichTextConverter.convertRrcXhtmlToHtml(response.doc);
						node.innerHTML = "";
						node.innerHTML = htmlText;
						node.insertBefore(titleSpan,node.firstChild);
						node.insertBefore(imageSpanNode, node.firstChild);
	
						if (embeddedLevel == 0) {
							self._connectHandles.push(
									self.connect(node, "ondblclick", self._handleArtifactDoubleClicked));
						}
						
						var links = dojo.query("a", node);
						for (var i = 0; i < links.length; i++) {
							var linkHref = links[i].attributes.getNamedItem("xmlsrc").value;
							if (ResourceLinksHandler.isLinkInternal(linkHref)) {
								//internal resource
								var href = queryutils.getFullyQualifiedUriFromAbsoluteResourceAndRelativeResource(resourceURI, linkHref);
								links[i].setAttribute("href", href);
							}
							self._connectHandles.push(
								self.connect(links[i], "onclick", self._handleAnchorClicked));
						}
						
						self._loadEmbeddedResources(node, embeddedLevel+1);//tail recursive call
						break;
					case com.ibm.rdm.web.common.MimeTypes.JPG.contentType:
					case com.ibm.rdm.web.common.MimeTypes.JPE.contentType:
					case com.ibm.rdm.web.common.MimeTypes.BMP.contentType:
					case com.ibm.rdm.web.common.MimeTypes.JPEG.contentType:
					case com.ibm.rdm.web.common.MimeTypes.GIF.contentType:
					case com.ibm.rdm.web.common.MimeTypes.PNG.contentType:
					case com.ibm.rdm.web.common.MimeTypes.ICO.contentType:
						node.src = node.attributes.getNamedItem("imgSrc").value + 
										((this.resourceViewer.projectSnapshotURI)?
											UriHelper.getResourceRevisionQueryAttribute(XhrUtils.getResponseEtag(response), true) + "&accept=none":
											"?accept=none"
										);
						dojo.removeClass(node, "dijitDisplayNone");
						//some images are coming back with the size 0
						//fix it removing the height and width attributes
						if (node.width < 2)
							//node.removeAttribute("width", false);
							node.setAttribute("width", "");
						if (node.height < 2)
							//node.removeAttribute("height", false);
							node.setAttribute("height", "");
						break;
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SKETCH:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PART:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SCREEN_FLOW:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_STORY_BOARD:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PROCESS:
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE_DIAGRAM:
						var normalizedResourceURI = resourceURI;
						var widget = com.ibm.rdm.web.viewer.embeddedResourceFactory.create(
							normalizedResourceURI, response, node, reviewParser, this.resourceViewer.projectSnapshotURI);
						node = widget.domNode;
						// Note: To be in alignment with the rich client, when the user clicks on an
						// embedded diagram (e.g. a Sketch, Part, etc) he/she is actually selecting
						// the _paragraph_ that contains the diagram (and text may appear above/below
						// the diagram within this paragraph).  For this reason, we take care here to
						// set an appropriate attribute on the parent node (a 'p' tag) so that when
						// it's selected the Commenting sidebar area is able to say something like
						// "Create a new comment for: Paragraph".
						node.parentNode.setAttribute(
							XML_ELEMENT_ATTRIBUTE_RDMTYPE, controlTypes.CONTROL_TYPES.Paragraph);
						// Add ability to double-click through to the embedded artifact.
						//var shortnameResourceURI = queryutils.getLastPathSegment(resourceURI);
						if (embeddedLevel == 0) {
							self._connectHandles.push(
								self.connect(node, "ondblclick", function(event) {
									self._handleArtifactDoubleClicked(event, resourceURI);
								}));
						}
						break;
					case com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_COLLECTION:
						var normalizedResourceURI = resourceURI;
						var span = document.createElement("SPAN");
						node.innerHTML = "";
						node.appendChild(span);
						var widget = com.ibm.rdm.web.viewer.embeddedResourceFactory.create(
							normalizedResourceURI, response, span, null, this.resourceViewer.projectSnapshotURI);
						node = widget.domNode;
						// Add ability to double-click through to the embedded artifact.
						//var shortnameResourceURI = queryutils.getLastPathSegment(resourceURI);
						if (embeddedLevel == 0) {
							self._connectHandles.push(
								self.connect(node, "ondblclick", function(event) {
									self._handleArtifactDoubleClicked(event, resourceURI);
								}));
						}
						break;
				}
			}
			else {
				// error
				// This catches the error when the current user does not have permission to view an embedded artifact.
				var resource = response.ioArgs.url.slice(response.ioArgs.url.lastIndexOf("/") + 1);
				resource = resource.substring(0, resource.indexOf("?"));
				var errorNode;
				if (node.id)
					errorNode = node;
				else if (node.parentNode.id)
					errorNode = node.parentNode;
				errorNode.innerHTML = dojo.string.substitute(this._messages.embeddedartifactnotfound, [resource]);
				errorNode.style.border="1px red solid";
				// TODO: some more hack to get rid of teh top error message
				if (response.ioArgs.xhr.status == 500) {
					if (!response.ioArgs.xhr.responseText.search (/AuthenticationException/i) == -1) {
						// The error was caused due to another reason. Display the error bar on top 
						com.ibm.rdm.web.common.ErrorHandler.getErrorSectionWidget().showErrorMessage(
								response.doc.message, response.ioArgs.xhr.responseText);
					}
				}
			}
			return response;
		};
		
		if (this.resourceViewer.reviewId) {
			var hashIndex = resourceId.indexOf("#");
			var normalizedResourceId =
				(hashIndex === -1 ? resourceId : resourceId.substring(0, hashIndex));
			var jazzResourceURI =
				queryutils.getFullyQualifiedUriFromAbsoluteResourceAndRelativeResource(
					this.resourceURI, normalizedResourceId);
			var artifactInfo = reviewParser.getArtifactInfo(resourceURI);
			var loadResourceByRevision = dojo.hitch(this, function(resourceURI, revisionId) {
				var deferred = RDMClient.doGet({
					uri: resourceURI,
					revision: revisionId
				});
				deferred.addBoth(self, onGetSuccess);
			});
			if (artifactInfo) {
				loadResourceByRevision(jazzResourceURI, artifactInfo.revision);
			} else {
				var onNewestPastRevisionByDateComplete = function(revisionsInfo) {
					var revisionToUse = revisionsInfo.revisionToUse;
					loadResourceByRevision(resourceURI, revisionToUse);
				}
				var deferred = revisionsHelper.getNewestPastRevisionByDate(
					resourceURI, reviewParser.getStartTimestampDate());
				deferred.addCallback(onNewestPastRevisionByDateComplete);
			}
		} 
		else if (this.resourceViewer.projectSnapshotURI) {
			//we need to run a query to get the exact revion of an artifact in snapshot
			var resourceDescriptionInSnapshotDeferred =
				ProjectCache.getResourceDescriptionMultiFetch(resourceURI, this.resourceViewer.projectSnapshotURI);
			resourceDescriptionInSnapshotDeferred.addCallback(this, function(resourceDescriptionInSnapshot){
				var resourceInSnapshotRevision = resourceDescriptionInSnapshot.etag;
				var snapshotResourceDeferred = RDMClient.doGet({
						uri: resourceURI,
						revision: resourceInSnapshotRevision,
						projectSnapshotURI: this.resourceViewer.projectSnapshotURI
					});
				snapshotResourceDeferred.addBoth(self, onGetSuccess);
				return resourceDescriptionInSnapshot;
			});
		}
		else {
			var deferred = RDMClient.doGet({uri: resourceURI});
			deferred.addBoth(self, onGetSuccess);
		}
	},
	
	_trimResourceSrcAttribute: function(resourceSrc) {
		if (resourceSrc.indexOf("#") >= 0)
			resourceSrc = resourceSrc.substring(0, resourceSrc.indexOf("#"));
		return resourceSrc;
	},

	_showUnableToOpenContentTypeBody: function() {
		// var idoc = this._iframeDoc();
		var nativeURI = (
			"rpc:"
			+ "//"
			//TODO:+ this.repoAuth.jrsrepo.split('/')[2]
			+ encodeURI(this.resourceURI));
		var buf = (
			"<html><body><p style=\"color:#999999; margin:20px;\">" 
			+ dojo.string.substitute(this._messages.webunabletodisplay, ["<a href="+nativeURI+">", "</a>"])
			+ "</p></body></html>"
		);
		/*
		idoc.open();
		idoc.write(buf);
		idoc.close();
		*/
		this._contentPane.attr('content', buf);
	},

	_getConversionURL: function(
			resourceURI, normalizedContentType, revision,
			/*Optional*/storyboardFrameIndex, /*Optional*/reviewParser)
	{
		// summary:
		//    Return a URL appropriate for obtaining a converted GEF-based artifact.
		var urlToUse = (
			UriHelper.getGefDiagramConversionUri() + "?resourceURL="
			+ encodeURIComponent(resourceURI) + ".html"
			+ "&contentType=" + normalizedContentType.replace("+", "%2b")
			+ "&revision=" + revision);
		if (normalizedContentType === com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_STORY_BOARD
			&& storyboardFrameIndex > -1) {
			urlToUse += "&storyboardFrameIndex=" + storyboardFrameIndex;
		}
		if (reviewParser) {
			urlToUse += UriHelper.getReviewQueryParams(reviewParser);
		}
		else if (this.resourceViewer.projectSnapshotURI) {
			urlToUse += UriHelper.getBaselineQueryParams(this.resourceViewer.projectSnapshotURI);
		}
		return urlToUse;
	},

	_handleAnchorClicked: function(event) {
		var anchor = event.currentTarget;
		var href = anchor.attributes.getNamedItem("href").value;
		viewerutils.openResourceUsingAppropriateViewer(
						href, 
						this.resourceViewer.reviewId,
						this.resourceViewer.projectSnapshotURI);
	},

	_handleArtifactDoubleClicked: function(event, /*String?*/shortnameResourceURI) {
		// summary:
		//    Handle the case of the user double clicking on an artifact.
		// event:
		//    DOM event
		// shortnameResourceURI:
		//    To get around the fact that IE doesn't provide event.currentTarget
		//    we're passing this shortname of the resourceURI that was clicked
		//    on (e.g. "rrc9").  This is needed due to the fact that with
		//    embedded artifacts, the user most likely will double click on a
		//    dom element INSIDE the widget itself.  In the case of Firefox
		//    we'd be able to still get at the widget's domNode by asking for
		//    event.currentTarget, but with IE we only have event.srcElement
		//    and we'd have to cruise the parent heirarchy to find the
		//    appropriate enveloping widget's domNode.
		var resourceURIToUse = null;
		if (shortnameResourceURI) {
			resourceURIToUse = shortnameResourceURI;
		} else {
			var node = (dojo.isIE ? event.srcElement : event.currentTarget);
			if (node.attributes.getNamedItem("src")) {
				var src = node.attributes.getNamedItem("src").value;
				resourceURIToUse = src.split("?revision=")[0];
				resourceURIToUse = resourceURIToUse.split("?accept=")[0];
			}
		}
		if (resourceURIToUse) {
			viewerutils.openResourceUsingAppropriateViewer(
				resourceURIToUse,
				this.resourceViewer.reviewId,
				this.resourceViewer.projectSnapshotURI);
		}
	},

	_onLocationPaneSelected: function(resourceLocationId, resourceUri) {
		var node = null;
		if (resourceLocationId=="")
			node = this._getRootArtifactNode();
		else 
			node = this.idNodesMap[resourceLocationId];

		if (node) {
			this.select(node);
			com.ibm.rdm.web.util.autoscroller.scrollToNode(node, this._getRootArtifactNode());
		}
		else {
			this.unselect(this._selectedNode);
		}
	},

	_onLocationPaneHover: function(resourceLocationId, isHoverOver) {
		var node = null;
		if (resourceLocationId=="")
			node = this._getRootArtifactNode();
		else 
			node = this.idNodesMap[resourceLocationId];
		
		if (node) {
			if (isHoverOver)
				this.hoverOver(node);
			 else 
				this.hoverOut(node);
		}
	},

	_onHighlightComments: function(commentCounts) {
		//var f = this._getRootArtifactNode();
		// clear old highlight
		// TODO: can be done in one for loop
		for (var i=0; i<this._locationsMarkedForComments.length; i++) {
			var node = this._locationsMarkedForComments[i];
			if(node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE) == XML_ELEMENT_ATTRIBUTE_RDMTYPE_REQUIREMENT) {
				dojo.removeClass(node, "embeddedRTCommentHighlight");
			}
			else if(node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE) == XML_ELEMENT_ATTRIBUTE_RDMTYPE_RICHTEXT) {
				dojo.removeClass(node, "embeddedRTCommentHighlight");
			}
			else if(node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE) == XML_ELEMENT_ATTRIBUTE_RDMTYPE_USECASE) {
				dojo.removeClass(node, "embeddedRTCommentHighlight");
			}
			else if(node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE) == XML_ELEMENT_ATTRIBUTE_RDMTYPE_ACTOR) {
				dojo.removeClass(node, "embeddedRTCommentHighlight");
			}
			else {
				dojo.removeClass(node, "commentHighlight");
			}
		}
		this._removeCommentBubbles();
		this._locationsMarkedForComments = new Array();
		
		// highlight comments        
		for (resourceLocationId in commentCounts) {
			if (resourceLocationId) {
				var node = this.idNodesMap[resourceLocationId];
				if (node) {
					if(node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE) == XML_ELEMENT_ATTRIBUTE_RDMTYPE_REQUIREMENT) {
						dojo.addClass(node, "embeddedRTCommentHighlight");		
					}
					else if(node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE) == XML_ELEMENT_ATTRIBUTE_RDMTYPE_RICHTEXT) {
						dojo.addClass(node, "embeddedRTCommentHighlight");
					}
					else if(node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE) == XML_ELEMENT_ATTRIBUTE_RDMTYPE_USECASE) {
						dojo.addClass(node, "embeddedRTCommentHighlight");		
					}
					else if(node.getAttribute(XML_ELEMENT_ATTRIBUTE_RDMTYPE) == XML_ELEMENT_ATTRIBUTE_RDMTYPE_ACTOR) {
						dojo.addClass(node, "embeddedRTCommentHighlight");
					}
					else {	
						dojo.addClass(node, "commentHighlight");
					}
					this._locationsMarkedForComments.push(node);
					this._addCommentsCountToSelectedElement(node, commentCounts[resourceLocationId]);
				}
			}
		}
		
		this._positionCommentBubbles();
	},

	_clearLastResultsIfNeeded: function() {
		this._selectedNode = null;
		this._locationsMarkedForComments = new Array();
		for (var i = 0; i < this._connectHandles.length; i++) {
			this.disconnect(this._connectHandles[i]);
		}
		this._connectHandles = new Array();
	},

	_addCommentsCountToSelectedElement: function(oSelectedElement, iCommentsCount) {
		try {
			// var oCommentCountElement = this._iframeDoc().createElement("div");
			var oCommentCountElement = document.createElement("div");
			oCommentCountElement.id = oSelectedElement.id + "_commentsCount";
			oCommentCountElement.innerHTML = 
				'<table class="commentBubbleTable">' +
					'<tr>' +
						'<td>' +
							'<img style="vertical-align: middle;" src="com.ibm.rdm.web/commenting/images/comment.gif"/>' +
						'</td>' +
						'<td style="font-family:sans-serif;font-size:9pt;font-weight:normal;color:#033">' +
							iCommentsCount + 
						'</td>' +
					'</tr>' +
				'</table>';

			oSelectedElement.style.opacity = '0.6'; //mozilla
			oSelectedElement.style.filter = 'alpha(opacity=60)'; //IE
			oSelectedElement.style.zoom = '1'; //IE
			
			this._commentBubbles[oSelectedElement.id] = oSelectedElement.parentNode.appendChild(oCommentCountElement);
		}
		catch (e) {
			com.ibm.rdm.web.common.ErrorHandler.getErrorSectionWidget().showErrorNumber(
				7205, [], e
			);
		}
	},

	_positionCommentBubbles: function () {
		for (resourceLocationId in this._commentBubbles) {
			var commentBubble = this._commentBubbles[resourceLocationId];
			var node = this.idNodesMap[resourceLocationId]; //parese resource location id
			if (node) this._positionCommentBubble(node, commentBubble);
		}
	},

	_positionCommentBubble: function (node, oCommentBubble) {
		var targetNodeCoords = dojo.coords(node);
		oCommentBubble.style.position = "absolute";
		var topX = (
			this._isTextualContent ?
			((targetNodeCoords.t - oCommentBubble.clientHeight + 10)) : // TODO Why is that 10 needed?
			((targetNodeCoords.t - oCommentBubble.clientHeight))
		);
		if (dojo.hasClass(node, "embeddedRTCommentHighlight")) {
			topX -= 12;
		}
		oCommentBubble.style.top = topX + "px";
		var self = this;
		var getDiagramNodeLeft = function(node) {
			var left = 0;
			var parentNode = node.parentNode;
			if (dojo.hasClass(parentNode, "diagramElement")) {
				// Note: This handles the case of a "non top-level" control
				// (such as a Button control found inside a Window control).
				left = (
					(node.offsetLeft + node.clientWidth)
					- 23		// Accounts for comment bubble's width (plus >1 parent's border?)
				);
			} else {
				// Note: This handles the case of a "top-level" control.
				left = (
					(targetNodeCoords.l + targetNodeCoords.w)
					- 26		// Accounts for comment bubble's width (plus parent's border?)
				);
			}
			return left + "px";
		};
		var getRichTextNodeLeft = function(node) {
			var left = (
				(targetNodeCoords.l + targetNodeCoords.w)
				- 30			// Accounts for comment bubble's width
			);
			return left + "px";
		};
		oCommentBubble.style.left = (
			this._isTextualContent ?
			getRichTextNodeLeft(node) :
			getDiagramNodeLeft(node)
		);
	},

	_removeCommentBubbles: function (oUnselectedElement) {
		try {
			var commentBubbles = dojo.query("[id$='_commentsCount']", this._getRootArtifactNode()) //attribute end match
			for (var i=0; i<commentBubbles.length; i++)
				commentBubbles[i].parentNode.removeChild(commentBubbles[i]);
		}
		catch(e) {
			com.ibm.rdm.web.common.ErrorHandler.getErrorSectionWidget().showErrorNumber(
				7206, [], e
			);
		}
		this._commentBubbles = {};
	}

});

var COMMENTED_ELEMENT_BACKGROUND_COLOR = "#DAFFDA";
var COMMENTED_ELEMENT_BORDER = "2px solid #00FF00";
var SELECTED_ELEMENT_BORDER = "2px solid #316AC5";
var EMBEDDED_ELEMENT_BORDER = "1px solid #9D9DA1";
var EMBEDDED_ELEMENT_BACKGROUND_COLOR = "#E0DFE3";
var EMBEDDED_ELEMENT_PADDING = 2;
var HOVERED_ELEMENT_BORDER = "2px solid #F9E0A8";
//var SELECTED_ELEMENT_MARGIN = "-2px";
var IFRAME_BOTTOM_GAP = 20;

var PADDING_TOP = 15;

// CONNECTION_KINK_WIDTH
//    The width in pixels of a kink that overlays a connection.
//    This value must take into account the "connectionKink" CSS specification
//    for "border" and "width".
var CONNECTION_KINK_WIDTH = 12;

// CONNECTION_KINK_HEIGH
//    The width in pixels of a kink that overlays a connection.
//    This value must take into account the "connectionKink" CSS specification
//    for "border" and "height".
var CONNECTION_KINK_HEIGHT = 12;

var CONNECTION_HIT_TEST_PIXEL_DELTA_THRESHOLD = 10;

var XML_ELEMENT_ATTRIBUTE_RDMTYPE = "rdmtype";
var XML_ELEMENT_ATTRIBUTE_RDMTYPE_RICHTEXT = "richtext";
var XML_ELEMENT_ATTRIBUTE_RDMTYPE_DIAGRAM = "diagram";
var XML_ELEMENT_ATTRIBUTE_RDMTYPE_SKETCH = "sketch";
var XML_ELEMENT_ATTRIBUTE_RDMTYPE_PART = "part";
var XML_ELEMENT_ATTRIBUTE_RDMTYPE_REQUIREMENT = "requirement";
var XML_ELEMENT_ATTRIBUTE_RDMTYPE_USECASE = "usecase";
var XML_ELEMENT_ATTRIBUTE_RDMTYPE_ACTOR = "actor";

})();
