/*
 * Copyright (c) 2007, 2009. IBM Corporation
 * All rights reserved.
 */
(function() {
dojo.provide("com.ibm.rdm.web.common.IntegrationConnections");
dojo.require("com.ibm.rdm.web.server.client.RDMClient");

var RDMClient = com.ibm.rdm.web.server.client.RDMClient;
var Doors = "doors";

com.ibm.rdm.web.common.IntegrationConnections = {
    
	
    init: function(projectUri) {
		this._initializeServerConnections(projectUri);
    },

	_initializeServerConnections: function(projectUri) {
		var deferred = new dojo.Deferred();
		var projectServiceDocumentUrl = com.ibm.rdm.web.FRONTING_SERVICE_PROJECT_SERVICE_DOCUMENT;
		var getUrl = projectServiceDocumentUrl + "?resourceContext=" + projectUri;
		var projectServiceDocDeferred = RDMClient.doGet({
			uri: getUrl,
			parser: function(projectServiceDocResponse){
					var doorsService = null;
					var serviceNodes = projectServiceDocResponse.doc.getElementsByTagName("service");
					for (var i=0; i<serviceNodes.length; i++) {
						var serviceNode = serviceNodes[i];
						if(serviceNode.getAttribute("name") == Doors){
							doorsService = serviceNode.getAttribute("url");
							break;
						}	
					}
					return doorsService;
				}
		});
		projectServiceDocDeferred.addCallback(this, function(doorsServiceUrl){
			var doorsServiceDeferred = RDMClient.doGet({
				uri: doorsServiceUrl,
				parser: function(doorsServiceResponse){
						var doorsServer = null;
						var projectNode = doorsServiceResponse.doc.lastChild;
						if(projectNode){
							doorsServer = projectNode.getAttribute("Server")
						}
						return doorsServer;
					}
			});
			doorsServiceDeferred.addCallback(this, function(doorsServerLink){
				deferred.callback(doorsServerLink);
			});
			doorsServiceDeferred.addErrback(this, function(errorResponse){
				deferred.errback(errorResponse);
			});
		});
		return deferred;
	}
}

})();
