/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rdm.web.common.MimeTypes");

dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.rdm.web.common", "common");
dojo.require("dojox.collections.Dictionary");

if (!com.ibm.rdm.web.common.MimeTypes._initialized) {
	com.ibm.rdm.web.common.MimeTypes._initialized = true;
	com.ibm.rdm.web.common.MimeTypes._allMimeTypes = new dojox.collections.Dictionary();

	function createMimeType(name, ext, contentType, imageName, imageLargeName, imageHeaderName) {
		var bundle = "com.ibm.rdm.web";
		var imageDir = "common/images/resources/";
		var mimeType = {
			name: name,
			ext: ext,
			contentType: contentType,
			imageURI: dojo.moduleUrl(bundle, imageDir+imageName),
			imageLargeURI: dojo.moduleUrl(bundle, imageDir+imageLargeName),
			imageHeaderURI: dojo.moduleUrl(bundle, imageDir+imageHeaderName)
		};
		com.ibm.rdm.web.common.MimeTypes._allMimeTypes.add(mimeType.contentType, mimeType);
		return mimeType;
	};
	
	var messages = dojo.i18n.getLocalization("com.ibm.rdm.web.common", "common");
	
	//////////////////////////////////////////////////////////////////////////
	// public content types
	//////////////////////////////////////////////////////////////////////////
	
	// Artifact types
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RICH_TEXT = "application/x-com.ibm.rdm.richtext+xml";
	//   Sketching domain ...
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PART = "application/x-com.ibm.sid.part+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SCREEN_FLOW = "application/x-com.ibm.sid.screenFlow+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SKETCH = "application/x-com.ibm.sid.sketch+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_STORY_BOARD = "application/x-com.ibm.sid.storyboard+xml";
	//   BAW domain ...
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ACTOR = "application/x-com.ibm.rdm.ba.actor+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_GLOSSARY = "application/x-com.ibm.rdm.ba.glossary+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PROCESS = "application/x-com.ibm.rdm.ba.process+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_TERM = "application/x-com.ibm.rdm.ba.term+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE_DIAGRAM = "application/x-com.ibm.rdm.ba.usecase.diagram+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE = "application/x-com.ibm.rdm.ba.usecase+xml";
	// Comment type
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_COMMENT = "application/x-com.ibm.rdm.comment+xml";
	// Requirement type
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQUIREMENT = "application/x-com.ibm.rdm.requirement+xml";
	// Review related types
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REVIEW = "x-com.ibm.rdm.review/rdf+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REVIEW_RESULT = "x-com.ibm.rdm.review.result/rdf+xml";
	// Baseline type
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_BASELINE = "application/x-com.ibm.rdm.baseline+xml";
	// Doc types
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_DOCTYPE = "application/x-com.ibm.rdm.doctype+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQ_DOCTYPE = "application/x-com.ibm.rdm.doctype.requirement+xml";
	// Other types
	com.ibm.rdm.web.common.MimeTypes.ATTRIBUTE_GROUP = "application/x-com.ibm.rdm.attributegroupstyle+xml";
	com.ibm.rdm.web.common.MimeTypes.LINK_TYPE_PLACEHOLDER = "application/x-com.ibm.rdm.placeholderlink";
	com.ibm.rdm.web.common.MimeTypes.LINK_TYPE_EXTERNAL = "application/x-html";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_FOLDER = "application/x-com.ibm.rdm.folder";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_FOLDER_PROJECT = "application/x-com.ibm.rdm.folder.project";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_UPLOADED = "x-com.ibm.rdm.reference/rdf+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_COLLECTION = "x-com.ibm.rdm.collection/rdf+xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_FILTER = "x-com.ibm.rdm.saved-filter/rdf+xml";
	// Image
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_IMAGE = "image";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_IMAGES = "image/*";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_VIDEOS = "video/*";
	// Artifacts embedded as images
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_DIAGRAM = "diagram";
	// Application types
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ZIP = "application/zip";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_IRIS = "application/x-irise+html";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_JS = "application/x-javascript";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_XLS = "application/vnd.ms-excel";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PPT = "application/vnd.ms-powerpoint";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PRJ = "application/vnd.ms-project";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_DOC = "application/msword";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RTF = "application/msword";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ODP = "application/vnd.oasis.opendocument.presentation";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ODS = "application/vnd.oasis.opendocument.spreadsheet";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ODT = "application/vnd.oasis.opendocument.text";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_OTHER = "application/octet-stream";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PDF = "application/pdf";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RAVENFLOW = "application/x-ravenflow+html";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RTP = "application/rtf";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_TAR = "application/x-tar";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_TEX = "application/x-tec";
	
	// TEXT types
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_XML ="text/xml";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_HTML ="text/html";
	com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_TXT = "text/plain";
	
	
	
	//////////////////////////////////////////////////////////////////////////
	// public mime types
	//////////////////////////////////////////////////////////////////////////

	/** ********* Artifact Types ********* */
	com.ibm.rdm.web.common.MimeTypes.RICH_TEXT = createMimeType(messages["richTextDocument"], "rtxt", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RICH_TEXT, "richtext.gif", "document_24.gif", "header/richtext_ed.png");
	com.ibm.rdm.web.common.MimeTypes.PART = createMimeType(messages["part"], "part", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PART, "componentfile.gif", "part_24.gif", "header/part_ed.png");
	com.ibm.rdm.web.common.MimeTypes.SKETCH = createMimeType(messages["sketch"], "sketch", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SKETCH, "sketchfile.gif", "sketch_24.gif", "header/sketch_ed.png");
	com.ibm.rdm.web.common.MimeTypes.SCREEN_FLOW = createMimeType(messages["screenFlow"], "flow", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SCREEN_FLOW, "AppFlowDiagram.gif", "screenflow_24.gif", "header/screenflow_ed.png");
	com.ibm.rdm.web.common.MimeTypes.STORY_BOARD = createMimeType(messages["storyBoard"], "story", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_STORY_BOARD, "storyboard.gif", "storyboard_24.gif", "header/storyboard_ed.png");
	com.ibm.rdm.web.common.MimeTypes.GLOSSARY = createMimeType(messages["glossary"], "glossary", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_GLOSSARY, "glossary.gif", "glossary_24.gif", "header/glossary_ed.png");
	com.ibm.rdm.web.common.MimeTypes.TERM = createMimeType(messages["term"], "term", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_TERM, "glossary-term.gif", "glossary-term_24.gif", "header/term_ed.png");
	com.ibm.rdm.web.common.MimeTypes.PROCESS = createMimeType(messages["process"], "process", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PROCESS, "process_vw.gif", "process_24.gif", "header/process_ed.png");
	com.ibm.rdm.web.common.MimeTypes.USE_CASE_DIAGRAM = createMimeType(messages["useCaseDiagram"], "usecase_diagram", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE_DIAGRAM, "UseCaseModelFile.gif", "usecase_24.gif", "header/usecase_ed.png");
	com.ibm.rdm.web.common.MimeTypes.USE_CASE = createMimeType(messages["useCase"], "usecase", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE, "uc_resource.gif", "uc_resource_24.gif", "header/Usecase.png");
	com.ibm.rdm.web.common.MimeTypes.ACTOR = createMimeType(messages["actor"], "actor", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ACTOR, "Actor.gif", "actor_24.gif", "header/Actor.png");
	com.ibm.rdm.web.common.MimeTypes.REQUIREMENT = createMimeType(messages["requirement"], "requirement", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQUIREMENT, "requirement.gif", "requirement_24.gif", "header/requirement_ed.png");
	com.ibm.rdm.web.common.MimeTypes.COLLECTION = createMimeType(messages["collection"], "collection", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_COLLECTION, "collection_obj.gif", "collection_24.gif", "collection_ed.png");
			
	/** ********* Review Type ********* */
	// TODO Need artwork for appropriate icons
	com.ibm.rdm.web.common.MimeTypes.REVIEW =
		createMimeType(messages["review"], "review", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REVIEW,
			"review.gif", null, "review_hdr.png");

	/** ********* Baseline Type ********* */
	// TODO Need artwork for this Baseline icon at large size and header icon size
	com.ibm.rdm.web.common.MimeTypes.BASELINE =
		createMimeType(messages["baseline"], "baseline", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_BASELINE,
			"baseline_icon.gif", "external/external-doc.gif", "external/external-doc.gif");

	/** ********* Special Link Types ********* */
	com.ibm.rdm.web.common.MimeTypes.LINK_PLACEHOLDER = createMimeType(messages["placeholderLink"], "", com.ibm.rdm.web.common.MimeTypes.LINK_TYPE_PLACEHOLDER, "Link.gif", "external/external-doc.gif", "external/external_editor_ed.png");
	com.ibm.rdm.web.common.MimeTypes.LINK_EXTERNAL_URL = createMimeType(messages["externalURL"], "", com.ibm.rdm.web.common.MimeTypes.LINK_TYPE_EXTERNAL, "external/html.gif", "external/external-doc.gif", "external/external_editor_ed.png");

	/** ********* Grouped images/video types ********* */
	com.ibm.rdm.web.common.MimeTypes.ALL_IMAGE_TYPES = createMimeType(messages["imageTypes"], "", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_IMAGES, "external/image.gif", "external/image_24.gif", "external/image_40.png");
	com.ibm.rdm.web.common.MimeTypes.ALL_VIDEO_TYPES = createMimeType(messages["videoTypes"], "", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_VIDEOS, "external/video.gif", "external/video_24.gif", "external/video_40.png");

	/** ********* Uploaded Type ********* */
	com.ibm.rdm.web.common.MimeTypes.UPLOADED = createMimeType(messages["uploaded"], "", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_UPLOADED, "upload.gif", "external/external-doc.gif", "external/external_editor_ed.png");

	/** ********* TEXT Types ********* */
	com.ibm.rdm.web.common.MimeTypes.HTML = createMimeType(messages["htmlFile"], "htm", "text/html", "external/html.gif", "external/html_24.gif", "external/html_40.png");
	com.ibm.rdm.web.common.MimeTypes.XML = createMimeType(messages["xmlFile"], "xml", "text/xml", "external/xml.gif", "external/xml_24.gif", "external/xml_40.png");
	com.ibm.rdm.web.common.MimeTypes.TXT = createMimeType(messages["plainText"], "txt", "text/plain", "external/text.gif", "external/text_24.gif", "external/text_40.png");

	/** ******* APPLICATION Types ******** */
	com.ibm.rdm.web.common.MimeTypes.DOC = createMimeType(messages["microsoftWordDocument"], "doc", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_DOC, "external/ms-word.gif", "external/ms-word_24.gif", "external/ms-word_40.png");
	com.ibm.rdm.web.common.MimeTypes.RTF = createMimeType(messages["microsoftWordDocument"], "rtf", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RTF, "external/ms-word.gif", "external/ms-word_24.gif", "external/ms-word_40.png");
	com.ibm.rdm.web.common.MimeTypes.TAR = createMimeType(messages["tapeArchive"], "tar", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_TAR, "external/tape-archive.gif", "external/tape-archive_24.gif", "external/tape-archive_40.png");
	com.ibm.rdm.web.common.MimeTypes.TEX = createMimeType(messages["texFormat"], "tex", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_TEX, "external/tex.gif", "external/tex_24.gif", "external/tex_40.png");
	com.ibm.rdm.web.common.MimeTypes.PDF = createMimeType(messages["pdfDocument"], "pdf", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PDF, "external/pdf.gif", "external/pdf_24.gif", "external/pdf_40.png");
	com.ibm.rdm.web.common.MimeTypes.XLS = createMimeType(messages["microsoftExcelDocument"], "xls", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_XLS, "external/ms-excel.gif", "external/ms-excel_24.gif", "external/ms-excel_40.png");
	com.ibm.rdm.web.common.MimeTypes.PPT = createMimeType(messages["microsoftPowerPointDocument"], "ppt", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PPT, "external/external.gif", "external/external_editor_24.gif", "external/external_editor_ed.png");
	com.ibm.rdm.web.common.MimeTypes.PRJ = createMimeType(messages["microsoftProjectDocument"], "prj", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PRJ, "external/external.gif", "external/external_editor_24.gif", "external/external_editor_ed.png");
	com.ibm.rdm.web.common.MimeTypes.RTP = createMimeType(messages["realTimeTransportProtocol"], "rtp", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RTP, "external/rttp.gif", "external/rttp_24.gif", "external/rttp_40.png");
	com.ibm.rdm.web.common.MimeTypes.ZIP = createMimeType(messages["zipFile"], "zip", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_ZIP, "external/zip.gif", "external/zip_24.gif", "external/zip_40.png");
	com.ibm.rdm.web.common.MimeTypes.JS = createMimeType(messages["javascriptFile"], "js", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_JS, "external/jscript.gif", "external/jscript_24.gif", "external/jscript_40.png");
	com.ibm.rdm.web.common.MimeTypes.IRIS = createMimeType(messages["iRiseSimulation"], "irise", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_IRIS, "external/irise.gif", "external/irise_24.gif", "external/irise_40.png");
	com.ibm.rdm.web.common.MimeTypes.RAVENFLOW = createMimeType(messages["ravenFlow"], "raven", com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_RAVENFLOW, "external/ravenflow.gif", "external/ravenflow_24.gif", "external/ravenflow_40.png");

	/** ******************* IMAGE Types *********************** */
	com.ibm.rdm.web.common.MimeTypes.JPG = createMimeType(messages["jpgImage"], "jpg", "image/jpeg", "external/image.gif", "external/image_24.gif", "external/image_40.png");
	com.ibm.rdm.web.common.MimeTypes.JPEG = createMimeType(messages["jpegImage"], "jpeg", "image/jpeg", "external/image.gif", "external/image_24.gif", "external/image_40.png");
	com.ibm.rdm.web.common.MimeTypes.JPE = createMimeType(messages["jpeImage"], "jpe", "image/jpeg", "external/image.gif", "external/image_24.gif", "external/image_40.png");
	com.ibm.rdm.web.common.MimeTypes.GIF = createMimeType(messages["gifImage"], "gif", "image/gif", "external/image.gif", "external/image_24.gif", "external/image_40.png");
	com.ibm.rdm.web.common.MimeTypes.PNG = createMimeType(messages["pngImage"], "png", "image/png", "external/image.gif", "external/image_24.gif", "external/image_40.png");
	com.ibm.rdm.web.common.MimeTypes.ICO = createMimeType(messages["iconImage"], "ico", "image/x-icon", "external/image.gif", "external/image_24.gif", "external/image_40.png");
	com.ibm.rdm.web.common.MimeTypes.BMP = createMimeType(messages["bitmapImage"], "bmp", "image/bmp", "external/image.gif", "external/image_24.gif", "external/image_40.png");

	/** ******************* VIDEO Types *********************** */
	com.ibm.rdm.web.common.MimeTypes.MP4 = createMimeType(messages["mp4Video"], "mp4", "video/mp4", "external/video.gif", "external/video_24.gif", "external/video_40.png");
	com.ibm.rdm.web.common.MimeTypes.AVI = createMimeType(messages["aviVideo"], "avi", "video/x-msvideo", "external/video.gif", "external/video_24.gif", "external/video_40.png");
	com.ibm.rdm.web.common.MimeTypes.MV = createMimeType(messages["mvVideo"], "mv", "video/x-sgi-movie", "external/video.gif", "external/video_24.gif", "external/video_40.png");
	com.ibm.rdm.web.common.MimeTypes.MOV = createMimeType(messages["movVideo"], "mov", "video/quicktime", "external/video.gif", "external/video_24.gif", "external/video_40.png");
	com.ibm.rdm.web.common.MimeTypes.QT = createMimeType(messages["qtVideo"], "qt", "video/quicktime", "external/video.gif", "external/video_24.gif", "external/video_40.png");
	com.ibm.rdm.web.common.MimeTypes.MPEG = createMimeType(messages["mpegVideo"], "mpeg", "video/mpeg", "external/video.gif", "external/video_24.gif", "external/video_40.png");
	com.ibm.rdm.web.common.MimeTypes.MPG = createMimeType(messages["mpgVideo"], "mpg", "video/mpeg", "external/video.gif", "external/video_24.gif", "external/video_40.png");

	/** ******************* Generic Stream ********************* */
	com.ibm.rdm.web.common.MimeTypes.DEFAULT_MIME_TYPE = createMimeType(messages["otherTypes"], "", "application/octet-stream", "external/external.gif", "external/external_editor_24.gif", "external/external_editor_ed.png");
	
	//////////////////////////////////////////////////////////////////////////
	// public mime type groups
	//////////////////////////////////////////////////////////////////////////
	com.ibm.rdm.web.common.MimeTypes.VIDEO_TYPES = [
		com.ibm.rdm.web.common.MimeTypes.MP4,
		com.ibm.rdm.web.common.MimeTypes.AVI,
		com.ibm.rdm.web.common.MimeTypes.MV,
		com.ibm.rdm.web.common.MimeTypes.MOV,
		com.ibm.rdm.web.common.MimeTypes.MPEG,
		com.ibm.rdm.web.common.MimeTypes.QT,
		com.ibm.rdm.web.common.MimeTypes.MPG
	];

	com.ibm.rdm.web.common.MimeTypes.IMAGE_TYPES = [
		com.ibm.rdm.web.common.MimeTypes.JPEG,
		com.ibm.rdm.web.common.MimeTypes.JPG,
		com.ibm.rdm.web.common.MimeTypes.JPE,
		com.ibm.rdm.web.common.MimeTypes.GIF,
		com.ibm.rdm.web.common.MimeTypes.PNG,
		com.ibm.rdm.web.common.MimeTypes.ICO,
		com.ibm.rdm.web.common.MimeTypes.BMP
	];

	com.ibm.rdm.web.common.MimeTypes.LINK_TYPES = [
		com.ibm.rdm.web.common.MimeTypes.LINK_PLACEHOLDER,
		com.ibm.rdm.web.common.MimeTypes.LINK_EXTERNAL_URL
	];

	// Artifacts in order suggested by UX and as used by rich client
	com.ibm.rdm.web.common.MimeTypes.ARTIFACTS_ORDERED = [
		com.ibm.rdm.web.common.MimeTypes.GLOSSARY,
		com.ibm.rdm.web.common.MimeTypes.PROCESS,
		com.ibm.rdm.web.common.MimeTypes.USE_CASE_DIAGRAM,
		com.ibm.rdm.web.common.MimeTypes.USE_CASE,
		com.ibm.rdm.web.common.MimeTypes.ACTOR,
		com.ibm.rdm.web.common.MimeTypes.TERM,
		com.ibm.rdm.web.common.MimeTypes.REQUIREMENT,
		com.ibm.rdm.web.common.MimeTypes.PART,
		com.ibm.rdm.web.common.MimeTypes.SKETCH,
		com.ibm.rdm.web.common.MimeTypes.STORY_BOARD,
		com.ibm.rdm.web.common.MimeTypes.SCREEN_FLOW,
		com.ibm.rdm.web.common.MimeTypes.RICH_TEXT,
		com.ibm.rdm.web.common.MimeTypes.UPLOADED,
		com.ibm.rdm.web.common.MimeTypes.COLLECTION
	];

	// wrappers with image and video types grouped
	com.ibm.rdm.web.common.MimeTypes.ABBREVIATED_WRAPPERS = [
		com.ibm.rdm.web.common.MimeTypes.HTML,
		com.ibm.rdm.web.common.MimeTypes.XML,
		com.ibm.rdm.web.common.MimeTypes.TXT,
		com.ibm.rdm.web.common.MimeTypes.DOC,
		com.ibm.rdm.web.common.MimeTypes.TAR,
		com.ibm.rdm.web.common.MimeTypes.TEX,
		com.ibm.rdm.web.common.MimeTypes.PDF,
		com.ibm.rdm.web.common.MimeTypes.XLS,
		com.ibm.rdm.web.common.MimeTypes.PPT,
		com.ibm.rdm.web.common.MimeTypes.PRJ,
		com.ibm.rdm.web.common.MimeTypes.RTF,
		com.ibm.rdm.web.common.MimeTypes.RTP,
		com.ibm.rdm.web.common.MimeTypes.ZIP,
		com.ibm.rdm.web.common.MimeTypes.JS,
		com.ibm.rdm.web.common.MimeTypes.IRIS,
		com.ibm.rdm.web.common.MimeTypes.RAVENFLOW,
		com.ibm.rdm.web.common.MimeTypes.DEFAULT_MIME_TYPE,
		com.ibm.rdm.web.common.MimeTypes.ALL_IMAGE_TYPES,
		com.ibm.rdm.web.common.MimeTypes.COLLECTION,
		com.ibm.rdm.web.common.MimeTypes.ALL_VIDEO_TYPES
	];

	com.ibm.rdm.web.common.MimeTypes.WRAPPERS = [
		com.ibm.rdm.web.common.MimeTypes.HTML,
		com.ibm.rdm.web.common.MimeTypes.XML,
		com.ibm.rdm.web.common.MimeTypes.TXT,
		com.ibm.rdm.web.common.MimeTypes.DOC,
		com.ibm.rdm.web.common.MimeTypes.RTF,
		com.ibm.rdm.web.common.MimeTypes.TAR,
		com.ibm.rdm.web.common.MimeTypes.TEX,
		com.ibm.rdm.web.common.MimeTypes.PDF,
		com.ibm.rdm.web.common.MimeTypes.XLS,
		com.ibm.rdm.web.common.MimeTypes.PPT,
		com.ibm.rdm.web.common.MimeTypes.PRJ,
		com.ibm.rdm.web.common.MimeTypes.RTP,
		com.ibm.rdm.web.common.MimeTypes.ZIP,
		com.ibm.rdm.web.common.MimeTypes.JS,
		com.ibm.rdm.web.common.MimeTypes.IRIS,
		com.ibm.rdm.web.common.MimeTypes.RAVENFLOW,
		com.ibm.rdm.web.common.MimeTypes.JPG,
		com.ibm.rdm.web.common.MimeTypes.JPEG,
		com.ibm.rdm.web.common.MimeTypes.JPE,
		com.ibm.rdm.web.common.MimeTypes.GIF,
		com.ibm.rdm.web.common.MimeTypes.PNG,
		com.ibm.rdm.web.common.MimeTypes.ICO,
		com.ibm.rdm.web.common.MimeTypes.BMP,
		com.ibm.rdm.web.common.MimeTypes.MP4,
		com.ibm.rdm.web.common.MimeTypes.AVI,
		com.ibm.rdm.web.common.MimeTypes.MV,
		com.ibm.rdm.web.common.MimeTypes.MOV,
		com.ibm.rdm.web.common.MimeTypes.QT,
		com.ibm.rdm.web.common.MimeTypes.MPEG,
		com.ibm.rdm.web.common.MimeTypes.MPG,
		com.ibm.rdm.web.common.MimeTypes.DEFAULT_MIME_TYPE,
		com.ibm.rdm.web.common.MimeTypes.UPLOADED	
	];
};

com.ibm.rdm.web.common.MimeTypeRegistry = {
	getMimeTypeDisplayName: function(contentType) {
		var normalizedContentType = com.ibm.rdm.web.util.queryutils.getNormalizedContentType(contentType);
		var mimeType = com.ibm.rdm.web.common.MimeTypes._allMimeTypes.item(normalizedContentType);
		if (mimeType != undefined) {
			return mimeType.name;
		} else {
			return "Unknown";
		}
	},
	isWrapperResource: function(contentType) {
		var isWrapRsc = false;
		dojo.forEach(com.ibm.rdm.web.common.MimeTypes.WRAPPERS, function( mime ) {
			if( mime.contentType == contentType ) {
				isWrapRsc = true;
			}
		});
		return isWrapRsc;
	},
	isImageConversionContentType: function(contentType) {
		return (
			contentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SKETCH
			|| contentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PART
			|| contentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_SCREEN_FLOW
			|| contentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_PROCESS
			|| contentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_USE_CASE_DIAGRAM
			|| contentType == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_STORY_BOARD
		);
	},
	
	/**
	 * Returns a string representing the appropriate IMG "src" value for a
	 * 16x16 image corresponding to the passed contentType.
	 */
	getImageURI: function(contentType) {
		// TODO Add icons for image resources (JPEG/GIF) ... on eclipse these end up
		// coming from shimgvw.dll (due to a call to getSystemExternalEditorImageDescriptor
		// in DocumentUtil.java).
		var normalizedContentType =
			com.ibm.rdm.web.util.queryutils.getNormalizedContentType(contentType);
		var mimeType = com.ibm.rdm.web.common.MimeTypes._allMimeTypes.item(normalizedContentType);
		if (mimeType != undefined) {
			return mimeType.imageURI;
		} else {
			return null;
		}
	},
	
	/**
	 * Returns a string representing the appropriate IMG "src" value for a
	 * 24x24 image corresponding to the passed contentType.
	 */
	getLargeImageURI: function(contentType) {
		var normalizedContentType =
			com.ibm.rdm.web.util.queryutils.getNormalizedContentType(contentType);
		var mimeType = com.ibm.rdm.web.common.MimeTypes._allMimeTypes.item(normalizedContentType);
		if (mimeType != undefined) {
			return mimeType.imageLargeURI;
		} else {
			return null;
		}
	},
	
	getHeaderImageURI: function(contentType) {
		var normalizedContentType = com.ibm.rdm.web.util.queryutils.getNormalizedContentType(contentType);
		var mimeType = com.ibm.rdm.web.common.MimeTypes._allMimeTypes.item(normalizedContentType);
		if (mimeType != undefined) {
			return mimeType.imageHeaderURI;
		} else {
			return null;
		}
	}
};
