/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.common.ResourceParser");
dojo.require("com.ibm.rdm.web.util.domutils");
dojo.require("com.ibm.rdm.web.common.UriHelper");
dojo.require("com.ibm.rdm.web.server.XhrUtils");

var XhrUtils = com.ibm.rdm.web.server.XhrUtils;
var domutils = com.ibm.rdm.web.util.domutils;
var UriHelper = com.ibm.rdm.web.common.UriHelper;

dojo.declare(
	"com.ibm.rdm.web.common.ResourceParser",
	null,
{

	updateContext: null,
		
    ///////////////////////////////////////////////////////////////////////////////////
    // Private fields
	
    // _response: Raw response object that is not parsed
	_response: null,
	
    // _etag: etag for the resource that is being parsed
	_etag: null,
	
    ///////////////////////////////////////////////////////////////////////////////////
    // API
	getETag: function() {
		// summary:
		//    Returns etag for Recent Artifacts Feed for a project
		return this._etag;
	},
		
	getPropertyInfo: function() {
		// summary:
		//    Returns the original response from doing the GET on that 
		//	  resource URI
		return this._response;
	},
	
	parseResponse: function(response) {
		// summary:
		//    Method that stores the response object for later quick retrieval
		var doc = response.doc;
		this._etag = XhrUtils.getResponseEtag(response);
		this._response = response;
		return response;
	}

});

})();
