/*
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2008, 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/**
 * this module contains various dojo hacks and bug fixes
 */
dojo.provide("com.ibm.rdm.web.common.bootstrap");

dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.rdm.web.common", "common");

//Fix for IE hanging problem
if(dojo.isIE){

	/**
	 * Use this dojo hack for now instead of the one above
	 * Older versions of XMLHTTP are causing IE to hand due to the complex XML that is produced by JRS.
	 * Most modern computers have XMLHTTP6, where the problem is not reproducible.
	 * Below hack will tell dojo to use the latest available version of XMLHTTP in IE.
	 * Every RDM user must have MSXML6 installed:
	 * http://www.microsoft.com/downloads/details.aspx?FamilyId=993c0bcf-3bcf-4009-be21-27e85e1857b1&displaylang=en
	**/
	dojo._XMLHTTP_PROGIDS = ['MSXML2.XMLHTTP.6.0'];
    try{
		new ActiveXObject(dojo._XMLHTTP_PROGIDS[0]);
	}catch(e){
		var messages = dojo.i18n.getLocalization("com.ibm.rdm.web.common", "common");
		var exception = messages.ieUnsupportedXMLParserLine1 + "\n"
						+ messages.ieUnsupportedXMLParserLine2 + "\n"
						+ messages.ieUnsupportedXMLParserLine3 + "\n"
						+ messages.ieUnsupportedXMLParserLine4 + "\n";
		var isContinue = confirm(exception);
		//TODO: get the valid release notes URL
		if (!isContinue)
			window.location.href = "https://publib.boulder.ibm.com/infocenter/rpcmpose/v7r1m0/index.jsp?topic=/com.ibm.rational.rrc.help.doc/helpindex_rrc.html";
	}
}

//check supported browsers
var isBrowserSupported = false;
if (dojo.isFF) {
	if (dojo.isFF >= 2)
		isBrowserSupported = true;
}
else if(dojo.isIE) {
	if (dojo.isIE >= 7)
		isBrowserSupported = true;
}
if (!isBrowserSupported) {
	var messages = dojo.i18n.getLocalization("com.ibm.rdm.web.common", "common");
	var exception = messages.unsupportedBrowserLine1 + "\n" +
				messages.unsupportedBrowserLine2 + "\n"
				+ messages.ieUnsupportedXMLParserLine3 + "\n"
				+ messages.ieUnsupportedXMLParserLine4 + "\n";
	var isContinue = confirm(exception);
	//TODO: get the valid release notes URL
	if (!isContinue)
		window.location.href = "https://publib.boulder.ibm.com/infocenter/rpcmpose/v7r1m0/index.jsp?topic=/com.ibm.rational.rrc.help.doc/helpindex_rrc.html";
}