/*
 * Copyright (c) 2007, 2009. IBM Corporation
 * All rights reserved.
 */
(function() {
dojo.provide("com.ibm.rdm.web.common.richtext.RichTextConverter");
dojo.require("dojox.data.dom");

com.ibm.rdm.web.common.richtext.RichTextConverter = {

	//
	//	summary:
	//		applies XSLT stylesheet to the XML from RRC in order to transform it to HTML.
	//
	//	xml:
	//		either XML string or XML DOM
	xsltStylesheet: null,
    convertRrcXhtmlToHtml: function(xml) {
    	var xmlDoc = null;
    	if(dojo.isString(xml)) {
			xmlDoc = dojox.data.dom.createDocument(xml);
		}
		else {
			xmlDoc = xml;
		}

    	//create an empty xml doc
		if (!this.xsltStylesheet) {
			this.xsltStylesheet = dojox.data.dom.createDocument();
			//load XSLT stylesheet
			this.xsltStylesheet.async = false;
			//must be fully qualified path in order to show up in rich hover and viewlets!!!");
			this.xsltStylesheet.load(dojo.moduleUrl("com.ibm.rdm.web", "common/richtext/RichTextTransformer.xsl").toString());
		}

		var htmlString = "";
		if (dojo.isIE) {
			htmlString = xmlDoc.transformNode(this.xsltStylesheet);
		}
		else if (document.implementation && document.implementation.createDocument) {
			var xsltProcessor = new XSLTProcessor();
			xsltProcessor.importStylesheet(this.xsltStylesheet);
			var htmlDoc = xsltProcessor.transformToFragment(xmlDoc,document);
			//we must transform documentFragment into HTML string and do innerHTML, otherwise weird things begin happening if you use appendChild
			var divNode = document.createElement("DIV");
			divNode.appendChild(htmlDoc);
			htmlString =  divNode.innerHTML;
		}
		return htmlString;
	}
}

})();