/*
 * Copyright (c) 2007, 2009. IBM Corporation
 * All rights reserved.
 */
(function() {
dojo.provide("com.ibm.rdm.web.pages.WebUIinitializer");
dojo.require("jazz.ui.SearchBox");
dojo.require("dijit.Menu");
dojo.require("com.ibm.rdm.web.common.UriHelper");
dojo.require("com.ibm.rdm.web.viewer.RecentlyViewedSection");
dojo.require("com.ibm.rdm.web.common.ProjectCache");
dojo.require("com.ibm.rdm.web.search.QuickSearch");
dojo.require("com.ibm.rdm.web.server.client.RDMClient");
dojo.require("dojo.i18n");
dojo.require("com.ibm.rdm.web.pages.About");
dojo.require("com.ibm.rdm.web.common.ErrorHandler");

dojo.require("com.ibm.rdm.web.server.jfs.RRCOAuthInterceptor");
dojo.require("com.ibm.rdm.web.server.jfs.RRCOAuthDialog");

dojo.requireLocalization("com.ibm.rdm.web.pages", "application");

var RDMClient = com.ibm.rdm.web.server.client.RDMClient;
var UriHelper = com.ibm.rdm.web.common.UriHelper;
var WebUIinitializer = com.ibm.rdm.web.pages.WebUIinitializer;
var ProjectCache = com.ibm.rdm.web.common.ProjectCache;
var SearchBox = jazz.ui.SearchBox;
var ErrorHandler = com.ibm.rdm.web.common.ErrorHandler;

var FRONTING_GLOBAL_SERVICE_DOCUMENT = "GlobalServiceDocument";

jazz.client.internal.addResponseInterceptor(com.ibm.rdm.web.server.jfs.RRCOAuthInterceptor); 

/*
<GlobalServiceDocument  xmlns="http://www.ibm.com/xmlns/prod/jazz/requirements/1.0/"  xmlns:jfs="http://jazz.net/xmlns/prod/jazz/jfs/1.0/"  majorVersion="2"  version="2.0.0.0">
<service name="Attribute Groups" url="https://localhost:9443/rdm/attributeGroups"/>
<service name="Snapshots" url="https://localhost:9443/rdm/snapshots"/>
<service name="Bookmarks" url="https://localhost:9443/rdm/bookmarks"/>
<service name="Calm Query" url="https://localhost:9443/rdm/calmquery"/>
<service name="Comments" url="https://localhost:9443/rdm/comments"/>
<service name="Comments Feed" url="https://localhost:9443/rdm/commentsFeed"/>
<service name="Configuration" url="https://localhost:9443/rdm/configure"/>
<service name="Content-Type Handlers" url="https://localhost:9443/rdm/contenttypehandlers"/>
<service name="Counters" url="https://localhost:9443/rdm/counters"/>
<service name="Discovery" url="https://localhost:9443/rdm/discovery"/>
<service name="doors" url="https://localhost:9443/rdm/doors"/>
<service name="doors migration" url="https://localhost:9443/rdm/doorsmigration"/>
<service name="Folders" url="https://localhost:9443/rdm/folders"/>
<service name="Friends" url="https://localhost:9443/rdm/friends"/>
<service name="Images" url="https://localhost:9443/rdm/images"/>
<service name="Links" url="https://localhost:9443/rdm/links"/>
<service name="Link Types" url="https://localhost:9443/rdm/linkTypes"/>
<service name="Mail" url="https://localhost:9443/rdm/mail"/>
<service name="Migration" url="https://localhost:9443/rdm/migration"/>
<service name="MultiFetch" url="https://localhost:9443/rdm/multi-fetch"/>
<service name="Multi Request" url="https://localhost:9443/rdm/multi-request"/>
<service name="Operations" url="https://localhost:9443/rdm/operations"/>
<service name="Project Resources" url="https://localhost:9443/rdm/project-resources"/>
<service name="Projects" url="https://localhost:9443/rdm/projects"/>
<service name="Publish" url="https://localhost:9443/rdm/publish"/>
<service name="Query" url="https://localhost:9443/rdm/query"/>
<service name="Resources" url="https://localhost:9443/rdm/resources"/>
<service name="RecentFeeds" url="https://localhost:9443/rdm/recentfeeds"/>
<service name="Review and Approval" url="https://localhost:9443/rdm/reviews"/>
<service name="Revisions" url="https://localhost:9443/rdm/revisions"/>
<service name="Tags" url="https://localhost:9443/rdm/tags"/>
<service name="Tag Count Feed" url="https://localhost:9443/rdm/tagCount"/>
<service name="Templates" url="https://localhost:9443/rdm/templates"/>
<service name="Warmup" url="https://localhost:9443/rdm/warmup"/>
<service name="Wrapper Resources" url="https://localhost:9443/rdm/wrapper-resources"/>
<jfs:service name="dc:title" url="Jazz Foundation Server (UNTITLED)"/>
<jfs:service name="jfs:oauthAccessTokenUrl" url="https://localhost:9443/jazz/oauth-access-token"/>
<jfs:service name="jp06:processSecurity" url="https://localhost:9443/jazz/process-security"/>
<jfs:service name="jfs:oauthRequestConsumerKeyUrl" url="https://localhost:9443/jazz/oauth-request-consumer"/>
<jfs:service name="jfs:currentUser" url="https://localhost:9443/jazz/whoami"/>
<jfs:service name="jfs:oauthRealmName" url="Jazz"/>
<jfs:service name="jfs:query" url="https://localhost:9443/jazz/query"/>
<jfs:service name="jfs:history" url="https://localhost:9443/jazz/history"/>
<jfs:service name="jfs:oauthApprovalModuleUrl" url="https://localhost:9443/jazz/_ajax-modules/com.ibm.team.repository.AuthorizeOAuth"/>
<jfs:service name="jfs:users" url="https://localhost:9443/jazz/users"/>
<jfs:service name="jp06:projectAreas" url="https://localhost:9443/jazz/process/project-areas"/>
<jfs:service name="jd:viewletServiceRoot" url="https://localhost:9443/jazz"/>
<jfs:service name="jp06:processTemplates" url="https://localhost:9443/jazz/process/templates"/>
<jfs:service name="jfs:baselines" url="https://localhost:9443/jazz/baselines"/>
<jfs:service name="jfs:oauthUserAuthorizationUrl" url="https://localhost:9443/jazz/oauth-authorize"/>
<jfs:service name="jfs:oauthRequestTokenUrl" url="https://localhost:9443/jazz/oauth-request-token"/>
<jfs:service name="jd:viewletWebUIRoot" url="https://localhost:9443/jazz"/>
<jfs:service name="jfs:mailer" url="https://localhost:9443/jazz/mailer"/>
<jfs:service name="jd:friends" url="https://localhost:9443/jazz/friends"/>
<jfs:service name="jfs:search" url="https://localhost:9443/jazz/search"/>
<jfs:service name="jfs:indexing" url="https://localhost:9443/jazz/indexing"/>
<jfs:service name="jfs:storage" url="https://localhost:9443/jazz/storage"/>
<jfs:service name="jfs:oauthDomain" url="https://localhost:9443/jazz"/>
</GlobalServiceDocument>
*/

var frontingServerServices = {
	"Service Document"					: "com.ibm.rdm.web.FRONTING_SERVICE_DOCUMENT",
	"Root Service"                        : "com.ibm.rdm.web.ROOT_SERVICE_DOCUMENT",
	"Attribute Groups"					: "com.ibm.rdm.web.FRONTING_SERVICE_ATTRIBUTE_GROUPS",
	"Bookmarks"							: "com.ibm.rdm.web.FRONTING_SERVICE_BOOKMARKS",
	"Comments"							: "com.ibm.rdm.web.FRONTING_SERVICE_COMMENTS",
	"Comments Feed"						: "com.ibm.rdm.web.FRONTING_SERVICE_COMMENTS_FEED",
	"Configuration"						: "com.ibm.rdm.web.FRONTING_SERVICE_CONFIGURATION",
	"Discovery"							: "com.ibm.rdm.web.FRONTING_SERVICE_DISCOVERY",
	"doors"								: "com.ibm.rdm.web.FRONTING_SERVICE_DOORS",
	"doors migration"					: "com.ibm.rdm.web.FRONTING_SERVICE_DOORS_MIGRATION",
	"Folders"							: "com.ibm.rdm.web.FRONTING_SERVICE_FOLDERS",
	"Links"								: "com.ibm.rdm.web.FRONTING_SERVICE_LINKS",
	"Link Types"						: "com.ibm.rdm.web.FRONTING_SERVICE_LINK_TYPES",
	"Mail"								: "com.ibm.rdm.web.FRONTING_SERVICE_MAIL",
	"Content-Type Handlers"				: "com.ibm.rdm.web.FRONTING_SERVICE_CONTENT_TYPE_HANDLERS",
	"Project Resources"					: "com.ibm.rdm.web.FRONTING_SERVICE_PROJECT_RESOURCES",
	"Publish"							: "com.ibm.rdm.web.FRONTING_SERVICE_PUBLISH",
	"Resources"							: "com.ibm.rdm.web.FRONTING_SERVICE_RESOURCES",
	"Tags"								: "com.ibm.rdm.web.FRONTING_SERVICE_TAGS",
	"Tag Count Feed"					: "com.ibm.rdm.web.FRONTING_SERVICE_TAG_COUNT_FEED",
	"Templates"							: "com.ibm.rdm.web.FRONTING_SERVICE_TEMPLATES",
	"Query"								: "com.ibm.rdm.web.FRONTING_SERVICE_QUERY",
 	"MultiFetch"						: "com.ibm.rdm.web.FRONTING_SERVICE_MULTI_FETCH",
	"RecentFeeds"						: "com.ibm.rdm.web.FRONTING_SERVICE_RECENT_FEEDS",
	"Review and Approval"				: "com.ibm.rdm.web.FRONTING_SERVICE_REVIEW_AND_APPROVAL",
	"Revisions"							: "com.ibm.rdm.web.FRONTING_SERVICE_REVISIONS",
	"Wrapper Resources"					: "com.ibm.rdm.web.FRONTING_SERVICE_WRAPPER_RESOURCES",
	"Migration"							: "com.ibm.rdm.web.FRONTING_SERVICE_MIGRATION",
	"Operations"						: "com.ibm.rdm.web.FRONTING_SERVICE_OPERATIONS",
	"Project Service Document"			: "com.ibm.rdm.web.FRONTING_SERVICE_PROJECT_SERVICE_DOCUMENT",
	"Projects"							: "com.ibm.rdm.web.FRONTING_SERVICE_PROJECTS",
	"Snapshots"							: "com.ibm.rdm.web.FRONTING_SERVICE_SNAPSHOTS",
	"Calm Query"						: "com.ibm.rdm.web.FRONTING_SERVICE_CALM_QUERY",
	"Counters"							: "com.ibm.rdm.web.FRONTING_SERVICE_COUNTERS",
	"Friends"							: "com.ibm.rdm.web.FRONTING_SERVICE_FRIENDS",
	"Images"							: "com.ibm.rdm.web.FRONTING_SERVICE_IMAGES",
	"Multi Request"						: "com.ibm.rdm.web.FRONTING_SERVICE_MULTI_REQUEST",
	"Warmup"							: "com.ibm.rdm.web.FRONTING_SERVICE_WARMUP",
	"dc:title"							: "com.ibm.rdm.web.FRONTING_TITLE",
	"jfs:oauthAccessTokenUrl"			: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_OAUTH_ACCESS_TOKEN_URL",
	"jfs:oauthRequestConsumerKeyUrl"	: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_OAUTH_REQUEST_CONSUMER_KEY_URL",
	"jfs:currentUser"					: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_CURRENT_USER",
	"jfs:oauthRealmName"				: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_OAUTH_REALM_NAME",
	"jfs:query"							: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_QUERY",
	"jfs:history"						: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_HISTORY",
	"jfs:users"							: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_USERS",
	"jd:viewletServiceRoot"				: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_VIEWLET_SERVICE_ROOT",
	"jfs:oauthUserAuthorizationUrl"		: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_OAUTH_USER_AUTHORIZATION_URL",
	"jfs:oauthRequestTokenUrl"			: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_OAUTH_REQUEST_ACCESS_TOKEN",
	"jd:viewletWebUIRoot"				: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_VIEWLET_WEBUI_ROOT",
	"jd:friends"						: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_FRIENDS",
	"jfs:search"						: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_SEARCH",
	"jfs:indexing"						: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_INDEXING",
	"jfs:storage"						: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_STORAGE",
	"jp06:projectAreas"					: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_PROJECT_AREAS",
	"jfs:oauthDomain"					: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_OAUTH_DOMAIN",
	"jfs:baselines"						: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_BASELINES",
	"jp06:processTemplates"				: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_PROCESS_TEMPLATES",
	"jp06:processSecurity"				: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_PROCESS_SECURITY",
	"jfs:oauthApprovalModuleUrl"		: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_PROCESS_SECURITY",
	"jfs:mailer"						: "com.ibm.rdm.web.FRONTING_SERVICE_JFS_PROCESS_SECURITY"
};

com.ibm.rdm.web.pages.WebUIinitializer = {
    
	_messages: dojo.i18n.getLocalization("com.ibm.rdm.web.pages", "application"),
    _jazzApplication: null,
    _projectsList: null,
    _projectsMenu: null,
	_userInitDeferred: null,
	
    init: function(jazzApplication) {
		this._jazzApplication = jazzApplication;
		this.initializeJFS();
		//this.initializeFooter();
    },
    
 	getDataServerRoot: function() {
    	var ret = net.jazz.ajax._contextRoot ? net.jazz.ajax._contextRoot : "/rdm";
    	return ret;
    },

    initializeFooter: function() {
    	//hardcode jazz.net footer links until branding solution is available.
    	this._jazzApplication.config.footer = {links: [ 
				{ label: this._messages.contact, href: "/legal/contact.jsp" },
				{ label: this._messages.termsOfUse, href: "/legal/terms.jsp" }
			]};
    },

	initializeJFS: function() {
		var deferred = this.initializeJFSForConfigProperties();
		deferred.addCallback(this, this.onInitializationDataRetreived);
	},
	
	initializeJFSForConfigProperties: function() {
		if (!this._userInitDeferred) {
			dojo.setObject(frontingServerServices["Service Document"], this.getDataServerRoot() + "/service-document"); //This is a service that we must hardcode, as it will serve as an entry point
			dojo.setObject(frontingServerServices["Root Service"], this.getDataServerRoot() + "/rootservices"); //This service is used for accessing build info about RRC.
			dojo.cookie("JazzFormAuth", "Form"); //https://jazz.net/jazz/web/projects/Jazz%20Foundation#action=com.ibm.team.workitem.viewWorkItem&id=86574
			this._userInitDeferred = new dojo.Deferred();
			var deferred = ProjectCache.getFrontingServerServiceDocument();
			deferred.addCallback(this, this.initializeFrontingServerServices);
			deferred.addCallback(this, function() {
					var whoamiDeferred = this.initializeCurrentUser();
					whoamiDeferred.addCallback(this, dojo.hitch(this, function() {
						this._userInitDeferred.callback();
					}));
				}	
			);
		}
		return this._userInitDeferred;
	},
	
    permissionsParser: function(projectURL, operationURL, response) {
		var permissionParser = new com.ibm.rdm.web.parsers.xml2json(response.doc);
		var parsedPermission = permissionParser.parse();
		var reportNode = permissionParser.getProperty(parsedPermission, 'operation-report');
		var status = reportNode.xmlAttributes["overallStatus"];
		var info = new Object;
		info.projectURL = projectURL;
		info.operationURL = operationURL;
		var isAllowed = null;
		if (status != "OK") {
			info.isAllowed = false;
		} else {
			var actionsNode = permissionParser.getProperty(reportNode, 'action-permissions');
			var actionNode = permissionParser.getProperty(actionsNode, 'action');
			var allowed = actionNode.xmlAttributes["allowed"];
			info.isAllowed = allowed == "true";
		}
 		return info;
	},

	initializeUserPermissions: function(response) {
		var userPermissionsDeferred = new dojo.Deferred();
		var userPermissions = new dojox.collections.Dictionary();
		
		var projects = null;
		var operations = null;
		
		var deferred = ProjectCache.getUserMemberProjects();
		deferred.addCallback(this, function(projectsResponse) {
			projects = projectsResponse;
 			for (var project in projects) {
				userPermissions.add(projects[project].url, new dojox.collections.Dictionary());
			}
			var operationsDeferred = ProjectCache.getOperations();
			operationsDeferred.addCallback(this, function(operationsResponse) {
				operations = operationsResponse;			
 				var multiGetArgs = [];
				for (var operation in operations) {
					var operationURL = operations[operation].url;
                	var lastSegment = operationURL.substring(operationURL.lastIndexOf("/")+1);
					if ((lastSegment == com.ibm.rdm.web.common.ProjectCache.MODIFY_COMMENT) || (lastSegment == com.ibm.rdm.web.common.ProjectCache.MODIFY_REVIEW_APPROVAL)) {
 						for (var project in projects) {
							var projectURL = projects[project].url;
							var permissionURL = operationURL + "?" 
								+ 'resourceContext=' + encodeURIComponent(projectURL) 
								+ "&amp;action=modify";
 							multiGetArgs.push ({
								uri: permissionURL,
								parser: dojo.hitch(this, this.permissionsParser, projectURL, operationURL)
							});
						}
					}
				}
 				var multiGetDeferred = ProjectCache.multiGet(multiGetArgs);					
				multiGetDeferred.addCallback(this, function(multiGetResponse) {
					for (var i=0; i<multiGetResponse.length; i++) {
						var info = multiGetResponse[i];
 						var projectOperations = userPermissions.item(info.projectURL);
                		var key = info.operationURL.substring(info.operationURL.lastIndexOf("/")+1);
 						projectOperations.add(key, info.isAllowed);
					}
					userPermissionsDeferred.callback(userPermissions);
				});
				multiGetDeferred.addErrback(this, function(response) {
	 				var errorSectionWidget = ErrorHandler.getErrorSectionWidget();
					if (errorSectionWidget) {
						errorSectionWidget.showErrorMessage(response);
					}
					userPermissionsDeferred.errback(response);
	 			});
			});
		});
		return userPermissionsDeferred;
	},
	
	initializeFrontingServerServices: function(response) {
		var globalServiceDoc = response.doc.getElementsByTagName(FRONTING_GLOBAL_SERVICE_DOCUMENT)[0];
        for (var i=0; i<globalServiceDoc.childNodes.length; i++) {
           	var serviceNode = globalServiceDoc.childNodes[i];
			if (serviceNode.nodeName == "service" || serviceNode.nodeName == "jfs:service") {
	       		var serviceName = serviceNode.getAttribute("name");
	       		var serviceURI = serviceNode.getAttribute("url");
				if (!frontingServerServices[serviceName]) {
					ErrorHandler.warn("unknown fronting server service: " + serviceName + "->" + serviceURI);
				}
				else {
	       			dojo.setObject(frontingServerServices[serviceName], serviceURI);
				}
			}
		}
	},
	
	initializeCurrentUser: function() {
		var userInitDeferred = new dojo.Deferred();
		var deferred = ProjectCache.getCurrentUser();
		deferred.addCallback(this, function(user) {
			dojo.setObject("com.ibm.rdm.web.AUTHENTICATED_USER", user);
			var permissionsDeferred = this.initializeUserPermissions();
			permissionsDeferred.addCallback(this, function(response) {
				user.permissions = response;
				userInitDeferred.callback();
				return response;
			});
			return user;
		});
		return userInitDeferred;
	},

	onInitializationDataRetreived: function(){
		this._jazzApplication.config.user = {
			name: com.ibm.rdm.web.AUTHENTICATED_USER.name,
			userId: com.ibm.rdm.web.AUTHENTICATED_USER.userId
		};
		this._jazzApplication.config.showLoginLogout = true;
		this._jazzApplication.config.logout = {
			callback: function (e) {
				var normalizePort = function(url) {
						var scheme = url.scheme || "http";
						if(!url.port) {
							url.port = scheme === "http" ? "80" : "443";
						}
					};
				dojo.stopEvent(e);
				dojo.cookie("rrs-cookie", null, {expires: -1, path: net.jazz.ajax._contextRoot});
				dojo.cookie("rrs-secret-cookie", null, {expires: -1, path: net.jazz.ajax._contextRoot});
				var dataServerRoot = new dojo._Url(net.jazz.ajax._dataServerRoot);
				normalizePort(dataServerRoot);
				if (dataServerRoot != null) {
					var realmMapping = dojo.cookie("jfs-oauth-realm-mapping");
					if (realmMapping) {
						var mapEntries = realmMapping.split("&");
						for (var i=0; i < mapEntries.length; i++) {
							var nameValPair = mapEntries[i].split("=");
							if (nameValPair.length == 2) {
								var cookieUrl = new dojo._Url(nameValPair[0]);
								normalizePort(cookieUrl);
								if (dataServerRoot.host === cookieUrl.host && dataServerRoot.port === cookieUrl.port && dataServerRoot.path.indexOf(cookieUrl.path) === 0) { 
									var index = nameValPair[1];
									dojo.cookie("jfs-oauth-access-token" + index, null, {expires: -1, path: net.jazz.ajax._contextRoot});
									dojo.cookie("jfs-oauth-access_token-secret" + index, null, {expires: -1, path: net.jazz.ajax._contextRoot});
									mapEntries.splice(i, 1);
									break;
								}
							}
						}
						dojo.cookie("jfs-oauth-realm-mapping", mapEntries.join("&"), {path: net.jazz.ajax._contextRoot});
					}
					
					var win = window.open(dataServerRoot.toString() + "/auth/logout", "logout", "width=300,height=300,location=0,status=0,scrollbars=0");
					var killLogoutPopup = function(e) {
						win.close();
						window.location.reload();
					}
					
					//kill logout popup once it is loaded and refresh the window
					if (dojo.isIE) {
						//IE7 popups do not dispatch "onload" events, so we need to come up with an alternative solution
						//19566: RRCWEB: Logout from dashboard --> Popup but no redisplay
						setInterval(
							function() {
								//check if logout popup is loaded, if so kill it
								if (win && win.document && win.document.body) {
									killLogoutPopup();
								}
							}, 200);
					}
					else {
						dojo.connect(win, "onload", killLogoutPopup);
					}
				} else {
					console.error("Unable to logout: dataServerRoot is not defined");
				}
				return false;
			}
		}
		this._jazzApplication.config.buttons.push({ //create the home button
			label: this._messages.dashboard,
			iconSrc: this._jazzApplication.productIconLarge,
			align: "left",
			//pageId: "com.ibm.team.dashboard"
			href: "#action=com.ibm.rdm.web.pages.showUserDashboard"
		});
		
		this._jazzApplication.config.buttons.push({
			label: this._messages.upperCaseHelp,
			iconSrc: dojo.moduleUrl("jazz.app", "graphics/JazzUI/icons/help.png"),
			align: "right",
			menuProvider: dojo.hitch(this,this._helpMenuProvider)
		});
		
		//create projects menu
		//TODO: connect refresh logic
		this._jazzApplication.config.navbarItems.push({
			label: this._messages.projects, 
			/*href: "#TODO",*/
			menuProvider: dojo.hitch(this, this.populateProjectsMenu)
		});
		this.populateProjectsMenu();
		
		this._jazzApplication.config.navbarItems.push({
			label: this._messages.recentlyViewed, 
			/*href: "#TODO",*/
			menuProvider: dojo.hitch(com.ibm.rdm.web.viewer.RecentlyViewedSection, com.ibm.rdm.web.viewer.RecentlyViewedSection._menuProvider)
		});

		//cant use foundation search box for now as it does not have what we want
		/*var SCOPE_ALL = "all";
		var searchBox = new SearchBox({
			scopes: [
				{id: SCOPE_ALL, label: "all", icon: dojo.moduleUrl("com.ibm.team.dashboard.web", "graphics/leftnav/icons/search-all.gif")}
			],
			onUpdate: dojo.hitch(this, this._onSearch),
			tooltip: this._messages.searchArtifacts,
			defaultText: this._messages.typeToSearch,
			noResultsLabel: this._messages.noResultsLabel,
		});*/
		var searchBox = new com.ibm.rdm.web.search.QuickSearch({
            actionHandler: dojo.hitch(this, function(userQueryString) {
                    window.location.href =
                        "#action=com.ibm.rdm.web.pages.showSearch"
                        + "&searchText="
                        + userQueryString;
                }
            )
        });
		this._jazzApplication.ui.bannerRightText.parentNode.insertBefore(searchBox.domNode, this._jazzApplication.ui.bannerRightText);
		searchBox.domNode.style.styleFloat = "right"; //IE
		searchBox.domNode.style.cssFloat = "right"; //Mozilla
		searchBox.domNode.style.position = "relative";
		searchBox.domNode.style.width = "200px";
		
		this.initializeHelp();
		
        // tell the framework to begin processing events (mandatory)
        this._jazzApplication.start();
	},

	
	_onSearch: function(/* string */ query, /* string */ scope, /* function */ callback, /* function */ errorCallback) {
		window.location.href =
            "#action=com.ibm.rdm.web.pages.showSearch"
            + "&searchText="
            + query;
	},
	
	_helpMenuProvider: function() {
		var menu = new dijit.Menu();
		dojo.addClass(menu.domNode,"jazz-app-Banner-helpmenu");
		// Hard coding this help URI until the help WAR is functioning correctly
		var helpuri = "http://publib.boulder.ibm.com/infocenter/rpcmpose/v2r0/topic/com.ibm.rational.rrc.help.doc/topics/t_use_rrc_webui.html";
		if (helpuri) {
			this.helpuri = helpuri;
			menu.addChild(new dijit.MenuItem({label: this._messages.upperCaseHelp, iconClass: 'helpIcon', onClick: dojo.hitch(this,this._openHelpContents)}));
		}
		menu.addChild(new dijit.MenuItem({label: this._messages.aboutRRC, onClick: dojo.hitch(this,this._openAboutBox)}));
		return menu;
	},
	_openHelpContents: function(event) {
		if (this.helpuri)
			window.open(this.helpuri,'help');
	},
	
	_openAboutBox: function(){
		var about = this._messages.RRCWebAppName;
		new com.ibm.rdm.web.pages.About({dialogTitle: about});
	},
	
	populateProjectsMenu: function() {
		this._projectsMenu = new dijit.Menu();
		dojo.addClass(this._projectsMenu.domNode,"jazz-app-BannerButton-menu");
		
		if (!this._projectsList) {
			var deferred = ProjectCache.getUserMemberProjects();
			deferred.addCallback(this, this.populateProjectsMenuCallback);
		}
		else {
			this.populateProjectsMenuCallback(this._projectsList);
		}
		return this._projectsMenu;
	},
	populateProjectsMenuCallback: function(projects) {
		for (var projectURL in projects) {
			this._projectsMenu.addChild(new dijit.MenuItem({
            	label: projects[projectURL].name,
            	onClick: dojo.hitch(this, this.navigateToProjectDashboard, projects[projectURL].url)
            }));
        }
		return projects;
	},
	navigateToProjectDashboard: function(projectURI) {
		window.location.href = "#action=com.ibm.rdm.web.pages.showProjectDashboard&projectURI=" + encodeURIComponent(projectURI);
	},
	initializeHelp: function() {
		// dashboard001, projecthome001, artifact001, review001, collection001, search001
		dojo.setObject("com.ibm.rdm.web.help.context", []);
		var cshContext = "com.ibm.rational.rrc.web.cshelp"
		com.ibm.rdm.web.help.context.search = cshContext + ".search001";
		com.ibm.rdm.web.help.context.project = cshContext + ".projecthome001";
		com.ibm.rdm.web.help.context.artifact = cshContext + ".artifact001";
		com.ibm.rdm.web.help.context.review = cshContext + ".review001";
		com.ibm.rdm.web.help.context.collection = cshContext + ".collection001";
		com.ibm.rdm.web.help.context.dashboard = cshContext + ".dashboard001";
	}
}

})();
