/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2008, 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.search.AttributeValueGroup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.form.ComboBox");
dojo.require("com.ibm.rdm.web.search.AttributeValue");


dojo.declare(
    "com.ibm.rdm.web.search.AttributeValueGroup",
    [dijit._Widget, dijit._Templated],
    {
        templatePath: dojo.moduleUrl("com.ibm.rdm.web", "search/templates/AttributeValueGroup.html"),
        widgetsInTemplate: true,

        ///////////////////////////////////////////////////////////////////////////////////
        // Attach points

        _headerLabelSpan: null,
        _attributeValueTableBody: null,

        ///////////////////////////////////////////////////////////////////////////////////
        // Public fields

        label: null,
        /**
         * The array of AttributeValue widgets that are to be displayed.
         */
        attributeValues: [],
        doRestrictToSingleSelection: false,

        ///////////////////////////////////////////////////////////////////////////////////
        // Private fields


        ///////////////////////////////////////////////////////////////////////////////////
        // API

        postCreate: function() {
            this._headerLabelSpan.appendChild(document.createTextNode(this.label));
            for (var i = 0; i < this.attributeValues.length; i++) {
                var attrValue = this.attributeValues[i];
                if (this.doRestrictToSingleSelection) {
                    attrValue.addCheckBoxValueChangedListener(this);
                }
                this._attributeValueTableBody.appendChild(attrValue.domNode);
            }
        },

        startup: function() {
            for (var i = 0; i < this.attributeValues.length; i++) {
                var attrValue = this.attributeValues[i];
                attrValue.startup();
            }
        },

        getQueryParams: function() {
            var queryParams = [];
            for (var i = 0; i < this.attributeValues.length; i++) {
                var attrValue = this.attributeValues[i];
                queryParam = attrValue.getQueryParam();
                if (queryParam) {
                    queryParams.push(queryParam);
                }
            }
            return (queryParams.length == 0 ? null : queryParams);
        },

        setFullTextEnablement: function(doEnableFulltext) {
            for (var i = 0; i < this.attributeValues.length; i++) {
                var attrValue = this.attributeValues[i];
                attrValue.setFullTextEnablement(doEnableFulltext);
            }
        },

        checkBoxValueHasChanged: function(selectedAttrValue) {
            for (var i = 0; i < this.attributeValues.length; i++) {
                var attrValue = this.attributeValues[i];
                if (attrValue != selectedAttrValue) {
                    attrValue.setChecked(false);
                }
            }
        }

        ///////////////////////////////////////////////////////////////////////////////////
        // Helpers

    }
);

})();
