/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2008, 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.search.PropertiesSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rdm.web.search.AttributeValue");
dojo.require("com.ibm.rdm.web.search.AttributeValueGroup");


dojo.declare(
    "com.ibm.rdm.web.search.PropertiesSection",
    [dijit._Widget, dijit._Templated],
    {
        templatePath: dojo.moduleUrl("com.ibm.rdm.web", "search/templates/PropertiesSection.html"),
        widgetsInTemplate: true,

        ///////////////////////////////////////////////////////////////////////////////////
        // Attach points

        _propertiesTableBody: null,

        ///////////////////////////////////////////////////////////////////////////////////
        // Private fields

        _tableRow: null,

        ///////////////////////////////////////////////////////////////////////////////////
        // API

        postCreate: function() {
            var tr = document.createElement("tr");
            this._propertiesTableBody.appendChild(tr);
            this._tableRow = tr;
        },

        addAttributeValueGroup: function(attributeValueGroup, previousAttributeValueGroup) {
            if (!this._displayedInDom(attributeValueGroup)) {
                var td = document.createElement("td");
                td.style.verticalAlign = "top";
                td.appendChild(attributeValueGroup.domNode);
                if (previousAttributeValueGroup) {
                    // Insert the new td element at a specific location
                    // (just after the td for previousAttributeValueGroup).
                    var previousTableData =
                        this._findTableDataContainingNode(previousAttributeValueGroup.domNode);
                    dojo.place(td, previousTableData, "after");
                } else {
                    // Insert the new td element as the first child of the tr element.
                    var firstChild = this._tableRow.firstChild;
                    if (firstChild) {
                        dojo.place(td, firstChild, "before");
                    } else {
                        this._tableRow.appendChild(td);
                    }
                }
            }
        },

        removeAttributeValueGroup: function(attributeValueGroup) {
            if (this._displayedInDom(attributeValueGroup)) {
                var td = attributeValueGroup.domNode.parentNode;
                td.removeChild(attributeValueGroup.domNode);
                td.parentNode.removeChild(td);
            }
        },

        ///////////////////////////////////////////////////////////////////////////////////
        // Helpers

        _findTableDataContainingNode: function(node) {
            var tdMatch = null;
            var tr = this._tableRow;
            for (var i = 0; i < tr.childNodes.length; i++) {
                var tableData = tr.childNodes[i];
                if (tableData.firstChild == node) {
                    tdMatch = tableData;
                    break;
                }
            }
            return tdMatch;
        },

        _displayedInDom: function(attributeValueGroup) {
            var node = attributeValueGroup.domNode;
            return (node.parentNode && node.parentNode.parentNode);
        }
    }
);

})();
