/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rdm.web.search.domutils");

dojo.require("com.ibm.rdm.web.search.results.ResourceAnchor");


com.ibm.rdm.web.search.domutils = {

    ///////////////////////////////////////////////////////////////////////////////////
    // Public

    // TODO Remove this function and change callers to make use of the version of this
    // function found in com.ibm.rdm.web.util.domutils instead.
    createSpannedTextNode: function(spanClassAttr, text) {
        var span = document.createElement("span");
        span.className = spanClassAttr;
        var text = document.createTextNode(text);
        span.appendChild(text);
        return span;
    },

    createTD: function(nodeOrNodes) {
        var td = document.createElement("td");
        this._addNodeOrNodesToElement(td, nodeOrNodes);
        return td;
    },

    createTR: function(nodeOrNodes) {
        var tr = document.createElement("tr");
        this._addNodeOrNodesToElement(tr, nodeOrNodes);
        return tr;
    },

    createProjectSpan: function(spanClassAttr, projectName) {
        // TODO We need a new image here that looks like a gray project folder
        // (instead of a gray folder).
        return this._createSpanContainingListOfImageAndText(
            spanClassAttr, "com.ibm.rdm.web/common/images/folder_gray.gif", projectName);
    },

    appendSecondaryResourceMatches: function(node, matchingValues) {
        for (var i = 0; i < matchingValues.length; i++) {
            var value = matchingValues[i];
            var labelIsSentenceBased = value.labelIsSentenceBased;
            // TODO Clip for long labels?
            var href = value.href;
            var displayLabel = value.displayLabel;
            if (href) {
                var resourceAnchor = new com.ibm.rdm.web.search.results.ResourceAnchor({
                    anchorTagClassAttr:"search-result-entry-secondary-resource",
                    text:displayLabel,
                    href:href
                }, null);
                resourceAnchor.startup();
                node.appendChild(resourceAnchor.domNode);
            } else {
                node.appendChild(com.ibm.rdm.web.search.domutils.createSpannedTextNode(
                    "search-result-entry-secondary-resource",
                    displayLabel));
            }
            if (matchingValues.length-1 != i) {
                node.appendChild(com.ibm.rdm.web.search.domutils.createSpannedTextNode(
                    "search-result-entry-secondary-resource-text", ","));
            }
        }
    },

    ///////////////////////////////////////////////////////////////////////////////////
    // Helpers

    _createSpanContainingListOfImageAndText: function(spanClassAttr, imageSrc, text) {
        var img = document.createElement("img");
        img.setAttribute("src", imageSrc);
        var span = document.createElement("span");
        span.className = spanClassAttr;
        span.appendChild(document.createTextNode("("));
        span.appendChild(img);
        span.appendChild(document.createTextNode(" " + text));
        span.appendChild(document.createTextNode(") "));
        return span;
    },

    _addNodeOrNodesToElement: function(element, nodeOrNodes) {
        if (nodeOrNodes instanceof Array) {
            var nodes = nodeOrNodes;
            for (var i = 0; i < nodes.length; i++) {
                element.appendChild(nodes[i]);
            }
        } else {
            element.appendChild(nodeOrNodes);
        }
        return element;
    }
};

