/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rdm.web.util.queryutils");

dojo.require("com.ibm.rdm.web.common.MimeTypes");
dojo.require("com.ibm.rdm.web.util.domutils");

var domutils = com.ibm.rdm.web.util.domutils;
/**

	Creates JS objects from various atom entry nodes returned by various JRS requests.

*/
com.ibm.rdm.web.util.queryutils = {

	DC_NAMESPACE: "http://purl.org/dc/elements/1.1/",
	DC_QUALIFIER: "dc",

	RDF_NAMESPACE: "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
	RDF_QUALIFIER: "rdf",
	
	RDFS_NAMESPACE: "http://www.w3.org/2000/01/rdf-schema#",
	RDFS_QUALIFIER: "rdfs",
	
	BASE_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Base/v0.1",
	BASE_QUALIFIER: "base",
	BASE_NAMESPACE_WITH_POUND: "http://jazz.net/xmlns/alm/rm/Base/v0.1#",
	
	NAV_NAMESPACE: "http://com.ibm.rdm/navigation#",
	NAV_QUALIFIER: "ns",
	
	EXTENSIONS_NAMESPACE: "http://jazz.net/xmlns/alm/rm/BPMNExtensions/v0.1",
	EXTENSIONS_QUALIFIER: "extensions",
	EXTENSIONS_NAMESPACE_WITH_POUND: "http://jazz.net/xmlns/alm/rm/BPMNExtensions/v0.1#",
	
	H_NAMESPACE: "http://www.w3.org/TR/REC-html40",
	H_QUALIFIER: "h",

	DCTERMS_NAMESPACE: "http://purl.org/dc/terms/",
	DCTERMS_QUALIFIER: "dcterms",
	
	USECASECONTEXT_NAMESPACE: "http://jazz.net/xmlns/alm/rm/UseCaseDiagram/v0.1",
	USECASECONTEXT_QUALIFIER: "usecasecontext",
	
	REVIEW_NAMESPACE: "http://www.ibm.com/xmlns/rrm/reviews/1.0/",
	REVIEW_QUALIFIER: "rrmReview",
	
	RPC_NAMESPACE: "http://jazz.net/xmlns/alm/rm/RichText/v0.1",
	RPC_QUALIFIER: "rte",
	
	GLOSSARY_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Glossary/v0.1",
	GLOSSARY_QUALIFIER: "glossary",
	
	TERM_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Term/v0.1",
	TERM_QUALIFIER: "term",

	SKETCH_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Sketch/v0.1",
	SKETCH_QUALIFIER: "sketch",

	PART_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Part/v0.1",
	PART_QUALIFIER: "part",

	SCREENFLOW_NAMESPACE: "http://jazz.net/xmlns/alm/rm/ScreenFlow/v0.1",
	SCREENFLOW_QUALIFIER: "flow",

	STORYBOARD_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Storyboard/v0.1",
	STORYBOARD_QUALIFIER: "story",

	BPMN20_NAMESPACE: "http://www.omg.org/bpmn20",
	BPMN20_QUALIFIER: "bpmn20",	
	
	EXTERNAL_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Reference/v0.1",
	EXTERNAL_QUALIFIER: "reference",
	
	USECASE_NAMESPACE: "http://jazz.net/xmlns/alm/rm/UseCase/v0.1",
	USECASE_QUALIFIER: "usecase",
	
	ACTOR_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Actor/v0.1",
	ACTOR_QUALIFIER: "actor",
	
	REQUIREMENT_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Requirement/v0.1",
	REQUIREMENT_QUALIFIER: "requirement",
	REQUIREMENT_NAMESPACE_WITH_POUND: "http://jazz.net/xmlns/alm/rm/Requirement/v0.1#",
	
	COLLECTION_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Collection/v1.0/",
	COLLECTION_QUALIFIER: "rrmCollection",
	UIACTIVITY_QUALIFIER:"UIActivity",
	
	USERINTERFACE_NAMESPACE: "http://jazz.net/xmlns/alm/rm/UserInterface/v0.1",
	USERINTERFACE_QUALIFIER: "ui",

	RRM_QUALIFIER: "rrm",
	RRM_NAMESPACE: "http://www.ibm.com/xmlns/rrm/1.0/",

	JFS_QUALIFIER: "jfs",
	JFS_NAMESPACE: "http://jazz.net/xmlns/foundation/1.0/",
	
	REFERENCE_NAMESPACE: "http://jazz.net/xmlns/alm/rm/Reference/v0.1#",
	
	DOORSRRCLINKTYPE: "/DoorsRRCLinkType",

	///////////////////////////////////////////////////////////////////////////
	// API

	// ** NOTE **: Please use getArtifactName instead of this function to avoid
	// problems in which the wrong "name" element is used (see 9435).
	getDisplayName: function(atomEntryNode) {
		// summary:
		//     If the original query asked for the user entered resource name (e.g. "Doc1")
		//     there should be an element in the entry node such as:
		//        <name xmlns="http://schema.ibm.com/rdm/2008/Base#">Doc1</name>
		//     Other similar examples include:
		//        <name xmlns="http://jazz.net/xmlns/alm/rm/BPMNExtensions/v0.1#">Proc102</name>
		//        <name xmlns="http://jazz.net/xmlns/alm/rm/Base/v0.1#">UC102</name>
		//     This function is called to pull this name out, or if no such element can
		//     be found it will return null.
		var displayName = "";
		var nodes = atomEntryNode.getElementsByTagName("name");
		for (var i = 0; i < nodes.length; i++) {
			var node = nodes[i];
			var namespaceURI = node.namespaceURI;
			if (namespaceURI
				&& (namespaceURI === "http://schema.ibm.com/rdm/2008/Base#"
					|| namespaceURI === "http://jazz.net/xmlns/alm/rm/BPMNExtensions/v0.1#"
					|| namespaceURI === "http://jazz.net/xmlns/alm/rm/Base/v0.1#"
					|| namespaceURI === "http://com.ibm.rdm/resource/extension#")) {
				displayName = (node.firstChild)? node.firstChild.nodeValue : "";
				break;
			}
		}
		return displayName;
	},

	getArtifactNameFromArtifactContent: function(/*XML*/ doc) {
		// summary:
		//    Given a doc representing an artifact's content, return the
		//    artifact name found within this document.
		// example:
		//    Here's a review:
		//      <rdf:RDF
		//          xmlns:dcterms="http://purl.org/dc/terms/"
		//          xmlns:dc="http://purl.org/dc/elements/1.1/"
		//          ...
		//          >
		//        <rrmReview:Review rdf:about="">
		//          <dcterms:description>my desc</dcterms:description>
		//          <dcterms:title>MyReview</dcterms:title>
		//          ...
		//        </rrmReview:Review>
		//      </rdf:RDF>
		//    Here's a document:
		//      <?xml version="1.0" encoding="UTF-8"?>
		//      <rte:text
		//          xmlns:dc="http://purl.org/dc/terms/" xmlns:h="http://www.w3.org/TR/REC-html40"
		//          xmlns:rte="http://jazz.net/xmlns/alm/rm/RichText/v0.1">
		//        <dc:description>my desc</dc:description>
		//        <dc:title>Doc1</dc:title>
		//          ...
		//      </rte:text>
		//    Most artifacts follow that format found in the document example ...
		//
		var artifactName = "";
		var node = (doc.childNodes[0].nodeName == 'xml') ? doc.childNodes[1] : doc.childNodes[0];
		var dcTermsNamespaceQualifier = this._getDcTermsNamespaceQualifier(node);
		var artifactNameNodes = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS( 
				node,
				"title",
				this.DCTERMS_NAMESPACE,
				dcTermsNamespaceQualifier
		);
		var artifactNameNodeToUse = artifactNameNodes[0];
		if (artifactNameNodes.length > 1) {
			// If more than one element within the doc is a "dc:title" we need
			// to set artifactNameNodeToUse to be the one that is closest to
			// the root of the doc (for example, in a Review, the review itself
			// uses a "dc:title" and so do all the artifacts listed within it
			// [and there's no guarantee on any kind of ordering for these
			// elements]).
			var getNodeDepth = function(node) {
				var depth = 1;
				var parent = node.parentNode;
				while (parent !== doc) {
					depth++;
					parent = parent.parentNode;
				}
				return depth;
			};
			var nameNodeClosestToRoot = null;
			var closestDepth = Number.MAX_VALUE;
			dojo.forEach(
				artifactNameNodes,
				function(artifactNameNode) {
					var depth = getNodeDepth(artifactNameNode);
					if (depth < closestDepth) {
						nameNodeClosestToRoot = artifactNameNode;
						closestDepth = depth;
					}
				}
			);
			artifactNameNodeToUse = nameNodeClosestToRoot;
		}
		if (artifactNameNodeToUse) {
			artifactName = artifactNameNodeToUse.firstChild.nodeValue;
		}
		return artifactName;
	},
	
	///////////////////////////////////////////////////////////////////////////////
	// Returns the description for a given resource from a document
	getDescriptionFromDoc: function(doc, contentType) {
		// summary:
		//    Get the description string that should appear in the header
		//    area.
		// example:
		//    Here's a review:
		//      <rdf:RDF
		//          xmlns:dcterms="http://purl.org/dc/terms/"
		//          xmlns:dc="http://purl.org/dc/elements/1.1/"
		//          ...
		//          >
		//        <rrmReview:Review rdf:about="">
		//          <dcterms:description>my desc</dcterms:description>
		//          <dcterms:title>MyReview</dcterms:title>
		//          ...
		//        </rrmReview:Review>
		//      </rdf:RDF>
		//    Here's a document:
		//      <?xml version="1.0" encoding="UTF-8"?>
		//      <rte:text
		//          xmlns:dc="http://purl.org/dc/terms/" xmlns:h="http://www.w3.org/TR/REC-html40"
		//          xmlns:rte="http://jazz.net/xmlns/alm/rm/RichText/v0.1">
		//        <dc:description>my desc</dc:description>
		//        <dc:title>Doc1</dc:title>
		//          ...
		//      </rte:text>
		//    Most artifacts follow that format found in the document example ...
		var artifactDescription = "";
		var node = (doc.childNodes[0].nodeName == 'xml') ? doc.childNodes[1] : doc.childNodes[0];
		var dcTermsNamespaceQualifier = this._getDcTermsNamespaceQualifier(node);
		var artifactDescriptionNode = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS( 
				node,
				"description",
				this.DCTERMS_NAMESPACE,
				dcTermsNamespaceQualifier
		);
		if (artifactDescriptionNode[0]) {
			artifactDescription =
				dojo.isIE ? artifactDescriptionNode[0].text : artifactDescriptionNode[0].textContent;
		}
		return artifactDescription;
	},

	getResourceURI: function(atomEntryNode) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//       ...
		//       <rdf:Description
		//         xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
		//         xmlns:dcterms="http://purl.org/dc/terms/"
		//         rdf:about="/jazz/resources/rdm/resources/res.media_1">
		//       </rdf:Description>
		//       ...
		//     you can make use of this function to pull out the resource URI:
		//         "/jazz/resources/rdm/resources/res.media_1"
		try {
			var descriptionNodes = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(
				atomEntryNode, "Description",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER);
			return (com.ibm.rdm.web.util.domutils.getAttributeNS(
				descriptionNodes[0], "about",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER));
		} catch(e) {
			console.error(e + "\nError caught and resolved by returning null for getResourceURI in queryutils");
			return null;
		}
	},	
	
	getReferenceResouceURI: function(atomEntryNode) {
		var referenceNodes = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(
			atomEntryNode, "reference", "http://com.ibm.rdm/resource/extension#");
		return (com.ibm.rdm.web.util.domutils.getAttributeNS(
			referenceNodes[0], "resource",
			this.RDF_NAMESPACE, this.RDF_QUALIFIER));
	},	
	getTagObject: function(atomEntryNode) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//    	<entry xmlns="http://www.w3.org/2005/Atom"
		//    		xmlns:navigation="http://com.ibm.rdm/navigation">
		//    	<title>Storyboards</title>
		//    	<category
		//    	scheme="http://com.ibm.rdm/category/tag" term="folder"/>
		//    	<navigation:summary>Imported Folder</navigation:summary>
		//    	<navigation:scope>public</navigation:scope>
		//    	<id>urn:jazzid:_qZ9kk4pdEd2GffwtE4VbXQ</id>
		//    	<updated>2008-09-24T13:24:37-04:00</updated>
		//    	<author>
		//    	<name>/jazz/users/ankur</name>
		//    	</author>
		//    	<link rel="self"
		//    		href="/jazz/resources/rdm/projectresources/4/rrc_tag5" type="application/atom+xml;type=entry"/>
		//    	<link rel="edit"
		//    		href="/jazz/resources/rdm/projectresources/4/rrc_tag5" type="application/atom+xml;type=entry"/>
		//    	</entry>
		//
		//     you can make use of this function to create a Tag object like this:
		//	  		{title: "Storyboards", author:"ankur", resourceURI:"rrc_tag5", term:"folder"}
		var tagObj = {};
		var titleNode = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(atomEntryNode, "title", this.DCTERMS_NAMESPACE, this.NAV_QUALIFIER)[0];
		var title = (titleNode.firstChild ? titleNode.firstChild.nodeValue : "");
		var descriptionNode = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(atomEntryNode, "description", this.DCTERMS_NAMESPACE, this.NAV_QUALIFIER)[0];
		var description = (descriptionNode.firstChild ? descriptionNode.firstChild.nodeValue : "");		
		var parentNode = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(
				atomEntryNode, "parent", this.NAV_NAMESPACE, this.NAV_QUALIFIER)[0];
		var parentURI = com.ibm.rdm.web.util.domutils.getAttributeNS(
				parentNode, "resource", this.RDF_NAMESPACE, this.RDF_QUALIFIER
			);
		var resourceURI = com.ibm.rdm.web.util.domutils.getAttributeNS(
				atomEntryNode, "about", this.RDF_NAMESPACE, this.RDF_QUALIFIER);
		
		tagObj.title = title;
		tagObj.description = description;
		tagObj.parentURI = parentURI;
		tagObj.resourceURI = resourceURI; //.substring(resourceURI.lastIndexOf("/") + 1);
		
		return tagObj;
	},
	
	getTags: function(atomEntryNode) { 	
		var tagNodes = atomEntryNode.getElementsByTagName("tag");
		var tags = [];
		for (var i=0; i<tagNodes.length; i++) {
			var tagURI = com.ibm.rdm.web.util.domutils.getAttributeNS(
				atomEntryNode, "resource", this.RDF_NAMESPACE, this.RDF_QUALIFIER
			);
			tags.push(tagURI);
		}
		return tags;
	},
	

	
	getContentTypeForWrapper: function( atomEntryNode ) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//       ...
		//       <contentType xmlns="http://jazz.net/xmlns/alm/rm/Reference/v0.1#">application/msword</contentType>
		//       ...
		//     you can make use of this function to pull out the resource URI:
		//         application/msword	
		
		return (com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(atomEntryNode, "contentType", 
			"http://jazz.net/xmlns/alm/rm/Reference/v0.1#")[0].firstChild.nodeValue);
	},    
	
	getResourceURIFromWrapper: function(atomEntryNode) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//       ...
  		//		<reference xmlns="http://jazz.net/xmlns/alm/rm/Reference/v0.1#" 
  		//			rdf:resource="/jazz/resources/rdm/resources/rrc66" /> 
		//       ...
		//     you can make use of this function to pull out the resource URI:
		//         "/jazz/resources/rdm/resources/rrc66"
		var uriNodes = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(
			atomEntryNode, "reference", "http://jazz.net/xmlns/alm/rm/Reference/v0.1#" );
		return (uriNodes) ?
			(com.ibm.rdm.web.util.domutils.getAttributeNS( uriNodes.item(0), "resource",
											this.RDF_NAMESPACE, this.RDF_QUALIFIER))
			: "" ;
	},

	getTitle: function(atomEntryNode) {
		// summary:
		//     The atomEntryNode contains an element of the following format:
		//       ...
		//       <title xmlns="http://www.w3.org/2005/Atom#">m1</title>
		//       ...
		//     This function can be called to pull this title element's node value
		//     out, which in this case would be "m1".
		var tagName = null;
		var nodes = atomEntryNode.getElementsByTagName("title");
		for (var i = 0; i < nodes.length; i++) {
			var node = nodes[i];
			var namespaceURI = node.namespaceURI;
			if (namespaceURI && namespaceURI === "http://www.w3.org/2005/Atom#") {
				tagName = node.firstChild.nodeValue;
				break;
			}
		}
		return tagName;
	},
	
	getRawTitle: function(atomEntryNode) {
		var title = null;
		var nodes = atomEntryNode.getElementsByTagName("title");
		for (var i = 0; i < nodes.length; i++) {
			var node = nodes[i];
			title = node.firstChild.nodeValue;
			break;
		}
		return title;
	},

	getFormat: function(atomEntryNode) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//       ...
		//       <dcterms:format>
		//         application/x-com.ibm.sid.sketch+xml;charset=UTF-8
		//       </dcterms:format>
		//       ...
		//     you can make use of this function to pull out the format (i.e. content
		//     type) which in this case would be:
		//         "application/x-com.ibm.sid.sketch+xml;charset=UTF-8"
		var formatNodes = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(
			atomEntryNode, "format",
			this.DCTERMS_NAMESPACE, this.DCTERMS_QUALIFIER);
		return formatNodes[0].firstChild.nodeValue;
	},
	
	getContent: function(atomEntryNode) {
		var contentType = com.ibm.rdm.web.util.domutils.getEntryBindingValueByName(atomEntryNode, "contentType");
		return contentType;
	},
	
	getFormatFromExtendedResourceQuery: function(atomEntryNode) {
		var formatNodes = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(
			atomEntryNode, "format", "http://com.ibm.rdm/resource/extension#");
		return formatNodes[0].firstChild.nodeValue;
	},

	getModifiedDate: function(atomEntryNode) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//       ...
		//       <dcterms:modified rdf:datatype="http://www.w3.org/2001/XMLSchema#dateTime">
		//         2008-05-23T10:35:44-04:00
		//       </dcterms:modified> 
		//       ...
		//     you can make use of this function to pull out the last modified date,
		//     which in this case would be a JS Date object representing:
		//         2008-05-23T10:35:44-04:00
		var displayName = null;
		var nodes = atomEntryNode.getElementsByTagName("modified");
		var modifiedDate = "";
		if (nodes.length>0) {
			var modifiedString = nodes[0].firstChild.nodeValue;
			modifiedDate = dojo.date.stamp.fromISOString(modifiedString);
		}
		return modifiedDate;
	},
	
	getModifiedDateFromExtendedResourceQuery: function(atomEntryNode) {
		var nodes = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(
			atomEntryNode, "modified", "http://com.ibm.rdm/resource/extension#");
		var modifiedDate = null;
		if (nodes.length > 0) {
			var modifiedString = dojo.isIE?(nodes[0].text):(nodes[0].textContent);
			modifiedDate = dojo.date.stamp.fromISOString(modifiedString);
		}
		return modifiedDate;    	
	},

	getCreatedDate: function(atomEntryNode) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//       ...
		//       <dcterms:created rdf:datatype="http://www.w3.org/2001/XMLSchema#dateTime">
		//         2008-06-27T10:27:23-04:00
		//       </dcterms:created> 
		//       ...
		//     you can make use of this function to pull out the artifact
		//     creation date, which in this case would be a JS Date object
		//     representing:
		//         2008-06-27T10:27:23-04:00
		var createdDate = null;
		var nodes = atomEntryNode.getElementsByTagName("created");
		if (nodes.length > 0) {
			var createdString = dojo.isIE?(nodes[0].text):(nodes[0].textContent);
			if (createdString)
				createdDate = dojo.date.stamp.fromISOString(createdString);
		}
		return createdDate;
	},

	getContributor: function(atomEntryNode) {
		// summary:
		//    If you have an atomEntryNode containing an element like the following:
		//        ...
		//        <dcterms:contributor rdf:resource="/jazz/users/Bob" />
		//        ...
		//    calling this method will pull out the "contributor" (i.e. the author
		//    that last modified the resource), which in this case is:
		//        "/jazz/users/Bob"
		var contributor = null;
		var contributorNodes = atomEntryNode.getElementsByTagName("contributor");
		if (contributorNodes.length > 0) {
			contributor = (com.ibm.rdm.web.util.domutils.getAttributeNS(
				contributorNodes[0], "resource",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER));
		}
		return contributor;
			
	}, 
	
	getProject: function(atomEntryNode) {
		// summary:
		//    If you have an atomEntryNode containing an element like the following:
		//        ...
		//        <dcterms:contributor rdf:resource="/jazz/users/Bob" />
		//        ...
		//    calling this method will pull out the "contributor" (i.e. the author
		//    that last modified the resource), which in this case is:
		//        "/jazz/users/Bob"
		var projectURI = null;
		var projectNodes = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(atomEntryNode, "resourceContext", this.JFS_NAMESPACE, this.JFS_QUALIFIER);
		if (projectNodes.length > 0) {
			projectURI = (com.ibm.rdm.web.util.domutils.getAttributeNS(
				projectNodes[0], "resource",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER));
		}
		return projectURI;
			
	}, 
	
	getContributorFromExtendedResourceQuery: function(atomEntryNode) {
		// summary:
		//    If you have an atomEntryNode containing an element like the following:
		//        ...
		//        <contributor rdf:resource="/jazz/users/Bob" />
		//        ...
		//    calling this method will pull out the "contributor" (i.e. the author
		//    that last modified the resource), which in this case is:
		//        "/jazz/users/Bob"
		var contributorNodes = atomEntryNode.getElementsByTagName("contributor");
		return (com.ibm.rdm.web.util.domutils.getAttributeNS(
			contributorNodes[0], "resource",
			this.RDF_NAMESPACE, this.RDF_QUALIFIER));
	},
	
	/**
		Returns an object {projectURI:<project uri}, projectName:<project's name>} from a given atom entry element
		as a result of GET on /teams
	*/
	getProjectNameFromTeamsEntry: function(atomEntryNode) {
			var result = {};
			// TODO: use domutils.xxxNS() methods
			var linkNodes = atomEntryNode.getElementsByTagName("link");
			var resourceURI = "";
			for (var j=0; j<linkNodes.length; j++) {
				var linkNode = linkNodes.item(j);
				var rel = linkNode.getAttribute("rel");
				
				if (rel=="self") {
					resourceURI = linkNode.getAttribute("href");
					result.projectURI = resourceURI;
					result.projectName = (atomEntryNode.getElementsByTagName("title")[0].firstChild.nodeValue);
					return result;
				}
			}
			return null
	},
	
	getNextPageURI: function(atomFeed) {
		var nextPageURI = null;
		// TODO: use domutils.xxxNS() methods
		var linkNodes = atomFeed.getElementsByTagName("link");
		for (var j = 0; j < linkNodes.length; j++) {
			var linkNode = linkNodes.item(j);
			var rel = linkNode.getAttribute("rel");
			if (rel == "next") {
				nextPageURI = linkNode.getAttribute("href");
				break;
			}
		}
		return nextPageURI;
	},

	getPrevPageURI: function(atomFeed) {
		var prevPageURI = null;
		// TODO: use domutils.xxxNS() methods
		var linkNodes = atomFeed.getElementsByTagName("link");
		for (var j = 0; j < linkNodes.length; j++) {
			var linkNode = linkNodes.item(j);
			var rel = linkNode.getAttribute("rel");
			if (rel == "previous") {
				prevPageURI = linkNode.getAttribute("href");
				break;
			}
		}
		return prevPageURI;
	},
	
	getPageCount: function(atomFeed) {
		var pageCount = 0;
		// TODO: use domutils.xxxNS() methods
		var linkNodes = atomFeed.getElementsByTagName("link");
		for (var j = 0; j < linkNodes.length; j++) {
			var linkNode = linkNodes.item(j);
			var rel = linkNode.getAttribute("rel");
			if (rel == "last") {
				var lastPageURI = linkNode.getAttribute("href");
				var startIndex = lastPageURI.indexOf("queryPage=") + 10;
				var endIndex = lastPageURI.indexOf("&", startIndex);
				pageCount = lastPageURI.substring(startIndex, endIndex);
				break;
			}
		}
		return pageCount;
	},
	
	getSelfLinkURI: function(atomFeed) {
		var selfLinkURI = null;
		// TODO: use domutils.xxxNS() methods
		var linkNodes = atomFeed.getElementsByTagName("link");
		for (var j = 0; j < linkNodes.length; j++) {
			var linkNode = linkNodes.item(j);
			var rel = linkNode.getAttribute("rel");
			if (rel == "self") {
				selfLinkURI = linkNode.getAttribute("href");
				break;
			}
		}
		return selfLinkURI;
	},
	
	getEditMediaLinkURI: function(atomFeed) {
		var editLinkURI = null;
		// TODO: use domutils.xxxNS() methods
		var linkNodes = atomFeed.getElementsByTagName("link");
		for (var j = 0; j < linkNodes.length; j++) {
			var linkNode = linkNodes.item(j);
			var rel = linkNode.getAttribute("rel");
			if (rel == "edit-media") {
				editLinkURI = linkNode.getAttribute("href");
				break;
			}
		}
		return editLinkURI;
	},
	
	getCollectionSize: function(atomFeed) {
		var collectionSizeNode = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(atomFeed, "collectionSize",
				"http://jazz.net/xmlns/v0.6", "jrs");
		return (collectionSizeNode[0])?
					collectionSizeNode[0].firstChild.nodeValue :
					null;
	},
	
	getNumberOfEntries: function(atomFeed) {
		var entryNodes = com.ibm.rdm.web.util.domutils.getElementsByTagNameNS(atomFeed, "entry");
		return (entryNodes.length) ? entryNodes.length : null;
	},
	
	getProjectNameFromQueryOrPropertiesEntry: function(atomEntryNode) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//       ...
		//       <rdf:Description
		//         xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
		//         xmlns:dcterms="http://purl.org/dc/terms/"
		//         rdf:about="/jazz/resources/rdm/resources/res.media_1">
		//         <owning-team xmlns="http://jazz.net/xmlns/properties/v0.6#"
		//           rdf:resource="/jazz/projects/rdm/teams/Project1"/>
		//       </rdf:Description>
		//       ...
		//     you can make use of this function to pull out the resource URI:
		//         "/jazz/projects/rdm/teams/Project1"
		var owningTeamNodes = atomEntryNode.getElementsByTagName("owning-team");
		return (com.ibm.rdm.web.util.domutils.getAttributeNS(
			owningTeamNodes[0], "resource",
			this.RDF_NAMESPACE, this.RDF_QUALIFIER));
	},

	getDescriptionFromQueryOrPropertiesEntry: function(atomEntryNode) {
		// summary:
		//    If you have an atomEntryNode containing an element like the following:
		//        <description xmlns="http://jazz.net/xmlns/alm/rm/Base/v0.1#">
		//          This part rocks
		//        </description>
		//    you can make use of this function to pull out the description:
		//        "This part rocks"
		//    [Note: You'll probably want to dojo.trim the result as normally the
		//    returned string has whitespace before/after it.]
		var description = null;
		var nodes = atomEntryNode.getElementsByTagName("description");
		for (var i = 0; i < nodes.length; i++) {
			var node = nodes[i];
			var namespaceURI = node.namespaceURI;
			if (namespaceURI && namespaceURI === this.BASE_NAMESPACE_WITH_POUND) {
				if (node.firstChild) {
					description = node.firstChild.nodeValue;
				}
				break;
			}
		}
		return description;
	},
	
	///////////////////////////////////////////////////////////////////////////////
	// Returns the parent URI from a given atom entry
	getParentURI: function(atomEntryNode) {
		// summary:
		//    If you have an atomEntryNode containing an element like the following:
		//        <parent xmlns="http://com.ibm.rdm/navigation#">
		//				/jazz/resources/rdm/publicTagLists/tagList.media/folder.entry
		//		  </parent> 
		//    you can make use of this function to pull out the parent URI:
		//        "/jazz/resources/rdm/publicTagLists/tagList.media/folder.entry"
		var folderURI = null;
		var nodes = atomEntryNode.getElementsByTagName("parent");
		for (var i = 0; i < nodes.length; i++) {
			var node = nodes[i];
			var namespaceURI = node.namespaceURI;
			if (namespaceURI && namespaceURI === this.NAV_NAMESPACE 
				|| namespaceURI === "http://com.ibm.rdm/navigation" ) {
				if (node.firstChild) {
					folderURI = node.firstChild.nodeValue;
				}
				break;
			}
		}
		return folderURI;
	},
	
	///////////////////////////////////////////////////////////////////////////////
	// Returns the Project owning name from a given atom entry
	getProjectOwningName: function(atomEntryNode) {
		// summary:
		//    Calls getProjectNameFromQueryOrPropertiesEntry function and trim off the last
		//    part of the URI to get the project name 
		var projectName = null;
		var projectURI = this.getProjectNameFromQueryOrPropertiesEntry( atomEntryNode );
		projectName = decodeURI(this.getLastPathSegment(projectURI));
		return projectName;
	},
	
	getCommentsCount: function(node){
		return node.getElementsByTagName("comment").length;
	},
	
	getNormalizedContentType: function(contentType) {
		// summary:
		//    Sometimes our content types are specified like this:
		//        application/x-com.ibm.sid.sketch+xml;charset=UTF-8
		//    and other times like this:
		//        application/x-com.ibm.sid.sketch+xml
		//    This function is called to prune, if needed, the string
		//    after the ";" ...
		var index = contentType.indexOf(';');
		return (index == -1 ? contentType : contentType.substring(0, index))
	},
	
	getTrimmedUserName: function(jrsUserName) {
		var index = jrsUserName.lastIndexOf("/");
		return (index == -1 ? jrsUserName : jrsUserName.substring(index+1));
	},
	
	/**
	 * E.g.
	 *   getLastPathSegment("/foo/Doc2")
	 *   ==> "Doc2"
	 */
	getLastPathSegment: function(pathUsingSlashes) {
		var lastSlashIndex = pathUsingSlashes.lastIndexOf("/");
		return (lastSlashIndex != -1 ? pathUsingSlashes.substring(lastSlashIndex+1) : pathUsingSlashes);
	},
	
	isEmptyString: function(/*String*/ str) {
		return (!str || str=="")?true:false;
   	},
   	
   	encode : function (string) {
		return escape(this._utf8_encode(string));
	},
	
	_utf8_encode : function (string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";
		for (var n = 0; n < string.length; n++) {
			var c = string.charCodeAt(n);
			if (c < 128) {
				utftext += String.fromCharCode(c);
			} else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			} else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
		}
		return utftext;
   	},
   	
  	asSearchId: function(searchText) {
		var trimmedStr= dojo.trim(searchText);
		
		var rrcFormat = /^[0-9]+$|^\([0-9]+\)$|^rrc[0-9]+$|^\(rrc[0-9]+\)$/;
        if (trimmedStr.length > 0 && rrcFormat.test(trimmedStr)) {
        	var searchIdStr = trimmedStr;
        	var startsWithRRC = /^rrc/;
        	
            if (searchIdStr.indexOf('(') != -1) {
            	searchIdStr = searchIdStr.substring(1);
            }
            if (searchIdStr.indexOf(')') != -1) {
            	searchIdStr = searchIdStr.substring(0, searchIdStr.length - 1);
            } 
            if(!startsWithRRC.test(searchIdStr)){
            	 searchIdStr = "rrc" + searchIdStr;
            }
            
			return searchIdStr;
		}
		return null;
	},

   	decode : function (utftext) {
   		// console.debug("original: "+utftext);
		return this._utf8_decode(unescape(utftext));
   	},
		
   	_utf8_decode : function (utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;
		while(i < utftext.length) {
			c = utftext.charCodeAt(i);
			if (c < 128) {
				if (c == 43) {
					string += " ";
				} else {
					string += String.fromCharCode(c);
				}
				i++;
			} else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			} else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
		}
		// console.debug("decoded: "+string);
		return string;
   	},

   	getFullyQualifiedUriFromRelativeLink: function(baseURI, relativeURI) {
		// baseURI:
		//    A path, such as "https://localhost:9443/rdm/resources/" or
		//    "https://localhost:9443/rdm/resources"
		// relativeURI:
		//    A relative path such as "../../jazz/baselines/_TZyjEKUZEd6-38oE2LC_yQ".
		// example:
		//    Calling:
		//        getFullyQualifiedUriFromRelativeLink(
		//            "https://localhost:9443/rdm/resources/",
		//            "../../jazz/baselines/_TZyjEKUZEd6-38oE2LC_yQ")
		//    would return:
		//        "https://localhost:9443/jazz/baselines/_TZyjEKUZEd6-38oE2LC_yQ"
		//    Also, the trailing slash may be left off, so calling:
		//        getFullyQualifiedUriFromRelativeLink(
		//            "https://localhost:9443/rdm/resources",
		//            "../../jazz/baselines/_TZyjEKUZEd6-38oE2LC_yQ")
		//    would return the same result:
		//        "https://localhost:9443/jazz/baselines/_TZyjEKUZEd6-38oE2LC_yQ"
		
		//sanity check
		if (relativeURI.indexOf("http") == 0) {
			return relativeURI;
		}
		
 		if (baseURI.lastIndexOf("/") != baseURI.length - 1) baseURI = baseURI + "/";
   		var array = relativeURI.split("../");
   		var _relativeURI = baseURI;
   		for (var i=0; i<array.length; i++) {
   			var _relativeURI = _relativeURI.substring(0, _relativeURI.lastIndexOf("/"));
   		}
   		var fullyQualifiedURI = _relativeURI + "/" + array[array.length-1]
   		return fullyQualifiedURI;
   	},
   	
	getFullyQualifiedUriFromAbsoluteResourceAndRelativeResource: function(
		absoluteResourceURI, relativeResourceURI)
	{
		// example:
		//    Calling:
		//        getFullyQualifiedUriFromAbsoluteResourceAndRelativeResource(
		//            "https://localhost:9443/rdm/resources/rrc102",
		//            "../../jazz/baselines/_TZyjEKUZEd6-38oE2LC_yQ")
		//    would return:
		//        "https://localhost:9443/jazz/baselines/_TZyjEKUZEd6-38oE2LC_yQ"
		var basePathURI = absoluteResourceURI.substring(0, absoluteResourceURI.lastIndexOf("/")+1);
		return this.getFullyQualifiedUriFromRelativeLink(basePathURI, relativeResourceURI);
	},
	
	sameLocation: function(uri1, uri2) {
		url1 = new dojo._Url(uri1);
		url2 = new dojo._Url(uri2);
		var same = (url1.scheme == url2.scheme)
			&& (url1.host == url2.host)
			&& (url1.port == url2.port);
		return same;
    },
   	
 	testRelativeURI: function() {
 		var uri = "";
 		uri = this.getRelativeUriFromFullyQualifiedUriLink("https://localhost:9443/rdm/comments/", "https://localhost:9443/rdm/resources/rrc12345");
 		if (uri != "../resources/rrc12345") alert("relative uri wrong");
 		uri = this.getRelativeUriFromFullyQualifiedUriLink("https://localhost:9443/rdm/comments/", "https://localhost:9443/rdm/reviews/12345");
 		if (uri != "../reviews/12345") alert("relative uri wrong");
 		uri = this.getRelativeUriFromFullyQualifiedUriLink("https://localhost:9443/rdm/comments/", "https://localhost:9443/rdm/comments/cc789");
 		if (uri != "cc789") alert("relative uri wrong");
 		uri = this.getRelativeUriFromFullyQualifiedUriLink("https://localhost:9443/rdm/comments/", "https://localhost:9443/rdm/comments/xyz/cc789");
 		if (uri != "xyz/cc789") alert("relative uri wrong");
 		uri = this.getRelativeUriFromFullyQualifiedUriLink("https://localhost:9443/rdm/comments/recentComments/", "https://localhost:9443/jazz/users/TestJazzAdmin1");
 		if (uri != "../../../jazz/users/TestJazzAdmin1") alert("relative uri wrong");
 	},
   	
   	getRelativeUriFromFullyQualifiedUriLink: function(baseURI, fullyQualifiedURI) {
 		// Example Usage (baseURI, fullyQualifiedURI) ==> relativeURI
 		// 	("https://localhost:9443/rdm/comments/", "https://localhost:9443/rdm/resources/rrc12345") ==> "../resources/rrc12345"
 		// 	("https://localhost:9443/rdm/comments/", "https://localhost:9443/rdm/reviews/12345") ==> "../resviews/rrc12345"
 		// 	("https://localhost:9443/rdm/comments/", "https://localhost:9443/rdm/comments/cc789") ==> "cc789"
 		// 	("https://localhost:9443/rdm/comments/", "https://localhost:9443/rdm/comments/xyz/cc789") ==> "xyz/cc789"
 		// 	("https://localhost:9443/rdm/comments/recentComments/", "https://localhost:9443/jazz/users/TestJazzAdmin1") ==> "../../../jazz/users/TestJazzAdmin1"
 		if (baseURI.lastIndexOf("/") != baseURI.length - 1) baseURI = baseURI + "/";
   		var baseArray = baseURI.split("/");
   		var fullyQualArray = fullyQualifiedURI.split("/");
   		var i = 0;
		while ((i < baseArray.length) && (i < fullyQualArray.length) && (baseArray[i] == fullyQualArray[i])) {
			i++;
		} 
		var relativeURI = null;   
		if (i == fullyQualArray.length && i == baseArray.length) {		
			relativeURI = "";  // same uri
		} else if (i == baseArray.length - 1) {
			relativeURI = "";   
			for (var j=i; j<fullyQualArray.length; j++) {
				relativeURI = relativeURI + fullyQualArray[j];
				if (j != fullyQualArray.length - 1) {
					relativeURI = relativeURI + "/";
				}
			}
		} else if (i == fullyQualArray.length - 1) {
			relativeURI = fullyQualArray[i];
		} else {
			relativeURI = "";   
			for (var j=i; j<baseArray.length - 1; j++) {
				relativeURI = relativeURI + "../";   
			}		
			for (var j=i; j<fullyQualArray.length; j++) {
				relativeURI = relativeURI + fullyQualArray[j];
				if (j != fullyQualArray.length - 1) {
					relativeURI = relativeURI + "/";
				}
			}
		}
		return relativeURI;
   	},
   	
   	/**
   	 * QUERY PARSING HELPER FUNCTIONS
   	 */
   	 getResourceDescriptionNodes: function(feed) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//       ...
		//       <rdf:Description>
		//         ...
		//       </rdf:Description>
		//       ...
		//     you can make use of this function to pull out the resource URI:
		//         "/jazz/resources/rdm/resources/res.media_1"
		try {
			var resourceDescriptionNodes = domutils.getElementsByTagNameNS(
				feed, "Description",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER);
			return resourceDescriptionNodes;
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	getResourceURIfromDescription: function(descriptionNode) {
		// summary:
		//     If you have an atomEntryNode containing an element like the following:
		//       ...
		//       <rdf:Description
		//         xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
		//         xmlns:dcterms="http://purl.org/dc/terms/"
		//         rdf:about="/jazz/resources/rdm/resources/res.media_1">
		//       </rdf:Description>
		//       ...
		//     you can make use of this function to pull out the resource URI:
		//         "/jazz/resources/rdm/resources/res.media_1"
		try {
			return (domutils.getAttributeNS(
				descriptionNode, "about",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER));
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getParentResouceURIfromDescription: function(descriptionNode) {
		//<ns:parent xmlns:ns="http://com.ibm.rdm/navigation#" rdf:resource="https://localhost:9443/rdm/folders/_TCf_4JihEd6qEbbZSstz8g"/>
		try {
			var parentNode = domutils.getElementsByTagNameNS(
				descriptionNode, "parent", this.NAV_NAMESPACE, this.NAV_QUALIFIER)[0];
			return (domutils.getAttributeNS(
				parentNode, "resource",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER));
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	
	getEtagFromDescription: function(descriptionNode) {
		// <ns:etag xmlns:ns="http://jazz.net/xmlns/foundation/1.0/">"_YsHTw5ihEd6qEbbZSstz8g"</ns:etag>  	
		try {
			var parentNode = domutils.getElementsByTagNameNS(
				descriptionNode, "etag", this.JFS_NAMESPACE, this.NAV_QUALIFIER)[0];
			var Etag = this.getTextNodeValue(parentNode);
			// Strip the leading/trailing double quotes off the etag
			return Etag.substring(1, Etag.length-1);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getFormatFromDescription: function(descriptionNode) {
		// <ns:format xmlns:ns="http://purl.org/dc/terms/">application/x-com.ibm.rdm.ba.process+xml</ns:format>  	
		try {
			var formatNode = domutils.getElementsByTagNameNS(
				descriptionNode, "format", this.DCTERMS_NAMESPACE, this.NAV_QUALIFIER)[0];
			return this.getTextNodeValue(formatNode);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getLastModifiedByFromDescription: function(descriptionNode) {
		// <ns:contributor xmlns:ns="http://purl.org/dc/terms/" rdf:resource="https://localhost:9443/jazz/users/TestJazzAdmin1"/>
		try {
			var contributorNode = domutils.getElementsByTagNameNS(
				descriptionNode, "contributor", this.DCTERMS_NAMESPACE, this.NAV_QUALIFIER)[0];
			return (domutils.getAttributeNS(
				contributorNode, "resource",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER));
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getLastModifiedDateFromDescription: function(descriptionNode) {
		// <ns:modified xmlns:ns="http://purl.org/dc/terms/">2009-09-03T15:49:38.172Z</ns:modified>
		try {
			var lastModifiedDateNode = domutils.getElementsByTagNameNS(
				descriptionNode, "modified", this.DCTERMS_NAMESPACE, this.NAV_QUALIFIER)[0];
			return this.getTextNodeValue(lastModifiedDateNode);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getCreatedDateFromDescription: function(descriptionNode) {
		// <ns:modified xmlns:ns="http://purl.org/dc/terms/">2009-09-03T15:49:38.172Z</ns:modified>		
		try {
			var createdDateNode = domutils.getElementsByTagNameNS(
				descriptionNode, "created", this.DCTERMS_NAMESPACE, this.NAV_QUALIFIER)[0];
			return this.getTextNodeValue(createdDateNode);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getTitleFromDescription: function(descriptionNode) {
		// <ns:title xmlns:ns="http://purl.org/dc/terms/">Update Shopping Cart</ns:title>
		try {
			var titleNode = domutils.getElementsByTagNameNS(
				descriptionNode, "title", this.DCTERMS_NAMESPACE, this.NAV_QUALIFIER)[0];
			return this.getTextNodeValue(titleNode);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getProjectURIFromDescription: function(descriptionNode) {
		// <ns:resource-context-id xmlns:ns="http://jazz.net/xmlns/foundation/1.0/">_Ox_M8ZihEd6qEbbZSstz8g</ns:resource-context-id>
		try {
			var contextNode = domutils.getElementsByTagNameNS(
				descriptionNode, "resourceContext", this.JFS_NAMESPACE, this.NAV_QUALIFIER)[0];
			return (domutils.getAttributeNS(
				contextNode, "resource",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER));
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getReferenceFromDescription: function(descriptionNode) {
		// <ns:reference xmlns:ns="http://jazz.net/xmlns/alm/rm/Reference/v0.1#" rdf:resource="https://localhost:9443/rdm/resources/rrc118"/>
		try {
			var referenceNode = domutils.getElementsByTagNameNS(
				descriptionNode, "reference", this.REFERENCE_NAMESPACE, this.NAV_QUALIFIER)[0];
			return (domutils.getAttributeNS(
				referenceNode, "resource",
				this.RDF_NAMESPACE, this.RDF_QUALIFIER));
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getContentTypeFromDescription: function(descriptionNode) {
		// <ns:contentType xmlns:ns="http://jazz.net/xmlns/alm/rm/Reference/v0.1#">image/jpeg</ns:contentType>
		try {
			var contentTypeNode = domutils.getElementsByTagNameNS(
				descriptionNode, "contentType", this.REFERENCE_NAMESPACE, this.NAV_QUALIFIER)[0];
			return this.getTextNodeValue(contentTypeNode);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getReviewTimestampFromDescription: function(descriptionNode) {
		// <j.2:reviewTimestamp>2009-09-05T02:19:43.901Z</j.2:reviewTimestamp>
		try {
			var reviewTimestampNode = domutils.getElementsByTagNameNS(
				descriptionNode, "reviewTimestamp", this.REVIEW_NAMESPACE, this.REVIEW_QUALIFIER)[0];
			return this.getTextNodeValue(reviewTimestampNode);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getReviewStatusFromDescription: function(descriptionNode) {
		// <j.2:reviewStatus>Started</j.2:reviewStatus>
		try {
			var node = domutils.getElementsByTagNameNS(
				descriptionNode, "reviewStatus", this.REVIEW_NAMESPACE, this.REVIEW_QUALIFIER)[0];
			return this.getTextNodeValue(node);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getLinkToReqProFromDescription: function(descriptionNode) {
		// <j.2:linkToReqPro></j.2:reviewStatus>
		try {
			var node = domutils.getElementsByTagNameNS(
				descriptionNode, "linkToReqPro", this.REQUIREMENT_NAMESPACE, this.REQUIREMENT_QUALIFIER)[0];
			return this.getTextNodeValue(node);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getReqProTagFromDescription: function(descriptionNode) {
		// <j.2:reqProTag></j.2:reviewStatus>
		try {
			var node = domutils.getElementsByTagNameNS(
				descriptionNode, "reqProTag", this.REQUIREMENT_NAMESPACE, this.REQUIREMENT_QUALIFIER)[0];
			return this.getTextNodeValue(node);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	getTextNodeValue: function(node) {
		try {
			return dojo.isIE?(node.text):(node.textContent);
		}
		catch(e) {
			console.error(e);
			return null;
		}
	},
	
	removeSpecialLuceneChars: function(userQueryString) {
     	// We need to escape special Lucene characters and remove punctuation chars. JFS Defect 67768
     	// Removal of punctuaution Chars takes precendence.
    	// The characters that need to be escaped are: + - & | ! ( ) { } [ ] ^ " ~ * ? : \ 
    	// Punctuation chars that need removal '()[]{}<>:,-!.?\";/ 
		if (!userQueryString) return userQueryString;
		userQueryString = userQueryString.replace(/\+/g, '\\+');
		userQueryString = userQueryString.replace(/\-/g, '');
		userQueryString = userQueryString.replace(/\&/g, '\\&');
		userQueryString = userQueryString.replace(/\|/g, '\\|');
		userQueryString = userQueryString.replace(/\!/g, '');
		userQueryString = userQueryString.replace(/\(/g, '');
		userQueryString = userQueryString.replace(/\)/g, '');
		userQueryString = userQueryString.replace(/\{/g, '');
		userQueryString = userQueryString.replace(/\}/g, '');
		userQueryString = userQueryString.replace(/\[/g, '');
		userQueryString = userQueryString.replace(/\]/g, '');
		userQueryString = userQueryString.replace(/\^/g, '\\^');
		userQueryString = userQueryString.replace(/\"/g, '');
		//Remove leading and trailing *'s
		userQueryString = userQueryString.replace(/^\*+|\*+$/g, '');
		userQueryString = userQueryString.replace(/\~/g, '\\~');
		userQueryString = userQueryString.replace(/\?/g, '');
		userQueryString = userQueryString.replace(/\:/g, '');
		
		userQueryString = userQueryString.replace(/\'/g, '');
		userQueryString = userQueryString.replace(/\</g, '');
		userQueryString = userQueryString.replace(/\>/g, '');
		userQueryString = userQueryString.replace(/\:/g, '');
		userQueryString = userQueryString.replace(/\,/g, '');
		userQueryString = userQueryString.replace(/\./g, '');
		userQueryString = userQueryString.replace(/\//g, '');
		userQueryString = userQueryString.replace(/\;/g, '');
		
		return userQueryString;
    },
    
    escapeQueryStringParameter: function(text) {
    	if (text && dojo.isString(text)) {
    		return text.replace(/"/g, '\\"');
    	}
    	else {
    		return text;
    	}
    },

	///////////////////////////////////////////////////////////////////////////
	// Helpers

	_getDcTermsNamespaceQualifier: function(node) {
		var dcTermsQualifierToUse = null;
		var attributes = node.attributes;
		for (var i = 0; i < attributes.length; i++) {
			var attr = attributes[i];
			var attrValue = dojo.isIE ? (attr.text) : (attr.textContent);
			if (attrValue === this.DCTERMS_NAMESPACE) {
				var attrName = dojo.isIE ? (attr.baseName) : (attr.localName);
				dcTermsQualifierToUse = attrName;
			}
		}
		return dcTermsQualifierToUse;
	}
};

