/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.rdm.web.viewer.ResourceViewerAjaxModule");//$NON-NLS-1$
	dojo.require("dijit._Widget");//$NON-NLS-1$
    dojo.require("dijit._Templated");//$NON-NLS-1$
    dojo.require("com.ibm.rdm.web.viewer.embeddedResourceFactory");
    dojo.require("com.ibm.rdm.web.viewer.ResourceViewer");
    dojo.require("com.ibm.rdm.web.pages.ActionViewCache");
    dojo.require("com.ibm.rdm.web.review.ReviewsViewer");
    dojo.require("com.ibm.rdm.web.review.ReviewCache");
    dojo.require("com.ibm.rdm.web.server.XhrUtils");

	var XhrUtils = com.ibm.rdm.web.server.XhrUtils;

    dojo.declare("com.ibm.rdm.web.viewer.ResourceViewerAjaxModule", [dijit._Widget, dijit._Templated], //$NON-NLS-1$ 
	{	
		widgetsInTemplate: true,
		templateString: "<div><div dojoAttachPoint='_test'></div></div>" ,
        
        postCreate: function(){
    		//this._test.appendChild(document.createTextNode("Loading..."));
    	
	        com.ibm.rdm.web.links.LinkCache.startup();
	        com.ibm.rdm.web.review.ReviewCache.startup();

    		//var resourceURI = ("/jazz/resources/rdm/resources/rrc5");

    	        var deferred = RDMClient.doGet(
    	        		resourceURI,
    	    			undefined,
    	    			undefined,
    	    			true);
    	        deferred.addCallback(this, this.onGetSuccess);
    	        return deferred;
    		
		},
		
		onGetSuccess: function(response){
			var resourceURI = this.gup("resourceUri");
			var widget = com.ibm.rdm.web.viewer.embeddedResourceFactory.create(
					resourceURI, response, this._test);
		},

	});
})();		

