/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rdm.web.viewlet.RRCViewlet");

dojo.require("com.ibm.rdm.web.pages.WebUIinitializer");
dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");

(function() {

var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;
var WebUIinitializer = com.ibm.rdm.web.pages.WebUIinitializer;

var _deferred;
var _isInitialized = false;

function _onInit() {
	_isInitialized = true;
}

/*
 * The base class for RRC viewlets.
 * 
 * The viewlets rely on the WebUIinitializer to be run, which is not the case
 * for remote viewlets in a cross-server dashboard. Viewlets must ensure that
 * the Web UI is initialized before loading.
 */
dojo.declare("com.ibm.rdm.web.viewlet.RRCViewlet",
	Viewlet, {
	
	constructor: function() {
		// initialize, if not already done
		if (!_isInitialized && !_deferred) {
			_deferred = WebUIinitializer.initializeJFSForConfigProperties();
			_deferred.addCallback(_onInit);
		}
	},
	
	/*
	 * Returns whether or not the Web UI is initialized.
	 */
	isInitialized: function() {
		return _isInitialized;
	},
	
	/*
	 * Waits for the Web UI to be initialized. Once initialized, the callback
	 * will be invoked.
	 */
	waitForInit: function(func) {
		_deferred.addCallback(func);
	}
});

})();
